<?php

global $wpdb;
$all_options = get_site_option('usa2levelhtml5map_options', array());
$options_keys = array_keys($all_options);
$def_map_id = reset($options_keys);

$map_id = isset($_GET['map_id']) ? (int)$_GET['map_id'] : $def_map_id;

if ( ! isset($all_options[$map_id]))
    $all_options[$map_id] = usa2level_map_plugin_map_defaults();

$map_options = &$all_options[$map_id];

if (usa2level_map_plugin_fix_old_map($map_options)) {
    update_site_option('usa2levelhtml5map_options', $all_options);
}

$id2cfg_map = $map_options['id2cfg'];
$main_continents   = json_decode($map_options['states']['main.cfg.js'], true);

$state_ids = $orig_states = (isset($_GET['state_id']) AND $_GET['state_id']) ? explode(':', $_GET['state_id']) : array();

$country_id = array_pop($state_ids);
$continent_id = array_pop($state_ids);

$has_substates = isset($id2cfg_map[$country_id]);

$cont_cfg_path = 'main.cfg.js';
$countries = $main_continents;
if ($country_id AND isset($id2cfg_map[$country_id])) {
    $cont_cfg_path = $id2cfg_map[$country_id];
    $countries = json_decode($map_options['states'][$cont_cfg_path], true);
}

$maxRadius = 15;

$dir     = plugins_url('/static/', __FILE__);
$doptions= usa2level_map_plugin_map_defaults();
$pointTypes = array(
    ""  => "Point",
);

$defOptions = usa2level_map_plugin_map_defaults('', 1, true);
foreach ($defOptions as $k => $v) {
    if (!isset($map_options['map'][$k]))
        $map_options['map'][$k] = $v;
}

function usa2level_map_plugin_quote_str($str) {
    return "'$str'";
}


if(isset($_POST['act_type']) && $_POST['act_type'] == 'usa2level-html5-map-points-save') {
    $points = (isset($_POST['map_points']) and $_POST['map_points']) ?  stripcslashes($_POST['map_points']) : '{}';
    if (($dcd = json_decode($points, true)) !== null AND is_array($dcd)) {
        foreach ($dcd as $pid => &$pointData) {
            if (!empty($pointData['info']))
                $map_options['info'][$pid] = wp_kses_post($pointData['info']);
            else
                unset($map_options['info'][$pid]);
            unset($pointData['info']);
        }
        unset($pointData);
        $map_options['points'][$cont_cfg_path] = $dcd;
    }
    if (isset($_POST['clear_saved_state']) and $_POST['clear_saved_state']) {
        unset($map_options['point_editor_settings']);
    } else {
        $es = (isset($_POST['editor_settings']) and $_POST['editor_settings']) ?  stripcslashes($_POST['editor_settings']) : '{}';
        $map_options['point_editor_settings'] = $es;
    }
    $map_options['map']['pointColor']             = sanitize_text_field($_POST['dPointColor']);
    $map_options['map']['pointColorOver']         = sanitize_text_field($_POST['dPointColorOver']);
    $map_options['map']['pointBorderColor']       = sanitize_text_field($_POST['dPointBorderColor']);
    $map_options['map']['pointBorderColorOver']   = sanitize_text_field($_POST['dPointBorderColorOver']);
    $map_options['map']['pointNameColor']         = sanitize_text_field($_POST['dPointNameColor']);
    $map_options['map']['pointNameColorOver']     = sanitize_text_field($_POST['dPointNameColorOver']);
    $map_options['map']['pointNameStrokeColor']   = sanitize_text_field($_POST['dPointNameStrokeColor']);
    $map_options['map']['pointNameStrokeColorOver'] = sanitize_text_field($_POST['dPointNameStrokeColorOver']);
    $map_options['map']['defaultPointRadius']     = min($maxRadius, max(1, (int) $_POST['dPointRadius']));
    $map_options['map']['pointNameFontSize']      = min(20, max(3, (int) $_POST['dPointFontSize']));
    $map_options['map']['pointNameFontFamily']    = sanitize_text_field(stripcslashes($_POST['dPointFontFamily']));
    $map_options['map']['pointColor']             = sanitize_text_field($_POST['dPointColor']);
    $map_options['update_time'] = time();
    usa2level_map_plugin_save_options($all_options);
}

$mce_options = array(
    //'media_buttons' => false,
    'editor_height'   => 150,
    'textarea_rows'   => 20,
    'textarea_name'   => 'pointAddInfo',
    'tinymce' => array(
        'add_unload_trigger' => false,
    )
);

$defaultEditorSettings = array(
    'color'                 => null,
    'colorOver'             => null,
    'borderColor'           => null,
    'borderColorOver'       => null,
    'nameColor'             => null,
    'nameColorOver'         => null,
    'nameStrokeColor'       => null,
    'nameStrokeColorOver'   => null,
    'nameFontSize'          => null,
    'radius'                => null,
    'textPosition'          => 'right-middle'
);

$editorSettings = (isset($map_options['point_editor_settings']) and ($settings = json_decode($map_options['point_editor_settings'], true))) ? $settings : array();
foreach ($defaultEditorSettings as $k => $v) {
    if (!array_key_exists($k, $editorSettings)) {
        $editorSettings[$k] = $v;
    }
}

echo "<div class=\"wrap\"><h2>" . __('Configuration of Map points', 'usa2level-html5-map') . "</h2>";
?>
<style>
.tipsy-w {
    z-index: 50500;
}
#TB_overlay, #TB_window {
    z-index: 50150 !important;
}
.ui-dialog {
    z-index: 50000 !important;
}
#adminmenuwrap {
    z-index: 40000 !important:
}
#editorButtons {
    padding: 0 -5px;
    float: right;
}
#editorButtons button {
    margin: 5px 5px;
}
.flamap-colorpicker {
    margin-left: 100px !important;
}
</style>
<script>
    var imageFieldId = false;
    jQuery(function($){

        $('.tipsy-q').tipsy({gravity: 'w'}).not('.page-title-action').css('cursor', 'default');

        $('.color~.flamap-colorpicker').each(function(){
            var me = this;

            $(this).farbtastic(function(color){
                var textColor = this.hsl[2] > 0.5 ? '#000' : '#fff';

                $(me).prev().prev().css({
                    background: color,
                    color: textColor
                }).val(color);

            });

            $.farbtastic(this).setColor($(this).prev().prev().val());

            $($(this).prev().prev()[0]).bind('change', function(){
                $.farbtastic(me).setColor(this.value);
            });

            $(this).hide();
            $(this).prev().prev().bind('focus', function(){
                $(this).next().next().fadeIn();
            });
            $(this).prev().prev().bind('blur', function(){
                $(this).next().next().fadeOut();
            });
        });


        window.send_to_editorArea = window.send_to_editor;

        window.send_to_editor = function(html) {
            if(imageFieldId === false) {
                window.send_to_editorArea(html);
            }
            else {
                var imgurl = $('img',html).prop('src');

                $('#'+imageFieldId).val(imgurl);
                imageFieldId = false;

                tb_remove();
            }

        }

        if (typeof tinyMCE !== 'undefined') tinyMCE.execCommand('mceAddControl', true, 'pointAddInfo')

        $('input[type=submit]').prop('disabled',false);

    });

    function adjustSubmit() {
        jQuery('#map_points').val(JSON.stringify(map.statePointsCfg()));
        jQuery('#editor_settings').val(JSON.stringify(editorSettings));
    }

</script>
<br />
<form method="POST" class="usa2levelhtml5map-html5-map" onsubmit="adjustSubmit()">
<?php
    usa2level_map_plugin_map_selector('points', $map_id, $all_options);
    echo "<br /><br />\n";
    usa2level_map_plugin_nav_tabs('points', $map_id);
?>

    <p><?php _e("Add points to the map. Double-click to add a point; click and hold to drag; double-click a point to edit it. To select the another level, use the drop-down menu.", "usa2level-html5-map"); ?></p>

    <?php
    echo usa2level_map_plugin_draw_map_menu2('points', $map_options, $map_id, $main_continents, $orig_states);
    ?>
    <br/><br/>
    <fieldset>
        <legend><?php _e('Points Configuration', 'usa2level-html5-map'); ?></legend>

        <div id="point_info"></div>
        <div>
        <div style="border-top: 1px solid #ddd">
                <label style="position: relative; top: -13px; background: white"><a href="javascript:void(0);" onclick="show_default_options(this.innerHTML.indexOf('+')!==-1)"><?php echo sprintf(__("Points defaults [%s]", "usa2level-html5-map"), "<span>+</span>") ?></a></label>
                <div id="pointDefOptionsWrapp" style="display: none">
                <table style="width: 100%">
                    <thead>
                    <tr style="font-weight: bold">
                        <td><?php _e('Option', 'usa2level-html5-map'); ?></td>
                        <td><?php _e('Color', 'usa2level-html5-map'); ?></td>
                        <td><?php _e('Hover color', 'usa2level-html5-map'); ?></td>
                        <td><?php _e('Selected color', 'usa2level-html5-map'); ?></td>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td><?php _e('Point color:', 'usa2level-html5-map'); ?></td>
                        <td><input class="color colorSimple" type="text" name="dPointColor" id="dPointColor" value="<?php echo $map_options['map']['pointColor'] ?>" style="background-color: <?php echo $map_options['map']['pointColor'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                        </td>
                        <td><input class="color colorOver" type="text" name="dPointColorOver" id="dPointColorOver" value="<?php echo $map_options['map']['pointColorOver'] ?>" style="background-color: <?php echo $map_options['map']['pointColorOver'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                        </td>
                        <td><input class="color colorSelected" type="text" name="dPointColorSelected" id="dPointColorSelected" value="<?php echo $map_options['map']['pointColorSelected'] ?>" style="background-color: <?php echo $map_options['map']['pointColorSelected'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                        </td>
                    </tr>
                    <tr>
                        <td><?php _e('Border color:', 'usa2level-html5-map'); ?></td>
                        <td><input class="color colorSimple" type="text" name="dPointBorderColor" id="dPointBorderColor" value="<?php echo $map_options['map']['pointBorderColor'] ?>" style="background-color: <?php echo $map_options['map']['pointBorderColor'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point border.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                        <td><input class="color colorOver" type="text" name="dPointBorderColorOver" id="dPointBorderColorOver" value="<?php echo $map_options['map']['pointBorderColorOver'] ?>" style="background-color: <?php echo $map_options['map']['pointBorderColorOver'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point border when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                        <td><input class="color colorSelected" type="text" name="dPointBorderColorSelected" id="dPointBorderColorSelected" value="<?php echo $map_options['map']['pointBorderColorSelected'] ?>" style="background-color: <?php echo $map_options['map']['pointBorderColorSelected'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point border when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                    </tr>
                    <tr>
                        <td><?php _e('Shortname color:', 'usa2level-html5-map'); ?></td>
                        <td><input class="color colorSimple" type="text" name="dPointNameColor" id="dPointNameColor" value="<?php echo $map_options['map']['pointNameColor'] ?>" style="background-color: <?php echo $map_options['map']['pointNameColor'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point\'s shortname.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                        <td><input class="color colorOver" type="text" name="dPointNameColorOver" id="dPointNameColorOver" value="<?php echo $map_options['map']['pointNameColorOver'] ?>" style="background-color: <?php echo $map_options['map']['pointNameColorOver'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point\'s shortname when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                        <td><input class="color colorSelected" type="text" name="dPointNameColorSelected" id="dPointNameColorSelected" value="<?php echo $map_options['map']['pointNameColorSelected'] ?>" style="background-color: <?php echo $map_options['map']['pointNameColorSelected'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point\'s shortname when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                    </tr>
                    <tr>
                        <td><?php _e('Shortname stroke color:', 'usa2level-html5-map'); ?></td>
                        <td><input class="color colorSimple" type="text" name="dPointNameStrokeColor" id="dPointNameStrokeColor" value="<?php echo $map_options['map']['pointNameStrokeColor'] ?>" style="background-color: <?php echo $map_options['map']['pointNameStrokeColor'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point\'s shortname stroke.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                        <td><input class="color colorOver" type="text" name="dPointNameStrokeColorOver" id="dPointNameStrokeColorOver" value="<?php echo $map_options['map']['pointNameStrokeColorOver'] ?>" style="background-color: <?php echo $map_options['map']['pointNameStrokeColorOver'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point\'s shortname stroke when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                        <td><input class="color colorSelected" type="text" name="dPointNameStrokeColorSelected" id="dPointNameStrokeColorSelected" value="<?php echo $map_options['map']['pointNameStrokeColorSelected'] ?>" style="background-color: <?php echo $map_options['map']['pointNameStrokeColorSelected'] ?>"  />
                        <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point\'s shortname stroke when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div></td>
                    </tr>
                    </tbody>
                </table>
                <hr>
                <div style="float:left; width: 20%">
                    <label><span class="title" style="width: 100px"><?php _e('Radius:', 'usa2level-html5-map') ?> </span>
                    <input type="number" name="dPointRadius" id="dPointRadius" value="<?php echo (int)$map_options['map']['defaultPointRadius'] ?>" style="width: 50px" min="1" max="<?php echo $maxRadius ?>"/>
                    <span class="tipsy-q" original-title='<?php esc_attr_e('The default point radius.', 'usa2level-html5-map'); ?>'>[?]</span>
                </div>
                <div style="float:left; width: 45%">
                    <label><span class="title"><?php _e('Name font family:', 'usa2level-html5-map') ?> </span>
                    <input type="text" name="dPointFontFamily" id="dPointFontFamily" value="<?php echo htmlspecialchars($map_options['map']['pointNameFontFamily']) ?>" style="width: 200px" />
                    <span class="tipsy-q" original-title='<?php esc_attr_e('The default font family for point\'s shortname.', 'usa2level-html5-map'); ?>'>[?]</span></td>
                </div>
                <div style="float:left; width: 35%">
                    <label><span class="title"><?php _e('Name font size:', 'usa2level-html5-map') ?> </span>
                    <input type="number" name="dPointFontSize" id="dPointFontSize" value="<?php echo (int)$map_options['map']['pointNameFontSize'] ?>" min="3" max="20" style="width: 100px" /> px
                    <span class="tipsy-q" original-title='<?php esc_attr_e('The default font size for point\'s shortname.', 'usa2level-html5-map'); ?>'>[?]</span></td>
                </div>
                <div style="clear:both"></div>
        </div>
            <div style="clear:both"></div>
            <hr>
            <div style="width: 50%; float: left">
            <label><?php _e('Enable zoom:', 'usa2level-html5-map') ?> <input type="checkbox" onchange="map.enableZoom(jQuery(this).prop('checked'), true)"></label>
            </div>
            <div style="width: 50%; float: left; display: none">
            <label><?php _e('Ignore editor saved state:', 'usa2level-html5-map') ?> <input type="checkbox" id="ignoreES"></label>
            </div>
            <div style="clear:both"></div>
        </div>
        <hr>
        <div id="map_container"></div>
    </fieldset>
    <fieldset style="display: none" id="pointEditor">
    <legend></legend>
        <div id="point_cfg">
        <?php
        $w = 32;
        $cp = count($pointTypes) > 1;
        if ($cp) $w = 25;
        if ($cp) {
        ?>
            <div style="float: left; width: <?php echo $w ?>%;">
                <label><span class="title" style="width: 80px"><?php _e('Point type:', 'usa2level-html5-map') ?> </span><select name="pointType" id="pointType" >
                <?php foreach ($pointTypes as $pt => $pn) { ?>
                <option value="<?php echo $pt ?>"><?php _e($pn, 'usa2level-html5-map') ?></option>
                <?php } ?>
                </select></label>
                <span class="tipsy-q" original-title="<?php esc_attr_e('Point type', 'usa2level-html5-map'); ?>">[?]</span><br />
            </div>
        <?php } ?>
            <div style="float: left; width: <?php echo $w ?>%;">
                <label><span class="title" style="width: 80px"><?php _e('X position:', 'usa2level-html5-map') ?> </span><input type="text" name="pointX" id="pointX" value="0" style="width: 50px"/></label>
                <span class="tipsy-q" original-title="<?php esc_attr_e('X position of the point', 'usa2level-html5-map'); ?>">[?]</span><br />
            </div>
            <div style="float: left; width: <?php echo $w ?>%;">
                <label><span class="title" style="width: 80px"><?php _e('Y position:', 'usa2level-html5-map') ?> </span><input type="text" name="pointY" id="pointY" value="0" style="width: 50px"/></label>
                <span class="tipsy-q" original-title="<?php esc_attr_e('Y position of the point', 'usa2level-html5-map'); ?>">[?]</span><br />
            </div>
            <div style="float: left; width: <?php echo $w ?>%;">
                <label><span class="title" style="width: 80px"><?php _e('Radius:', 'usa2level-html5-map') ?> </span><input type="number" name="pointRadius" id="pointRadius" value="4" style="width: 50px" min="0" max="<?php echo $maxRadius ?>"/></label>
                <span class="tipsy-q" original-title="<?php esc_attr_e('Radius of the point', 'usa2level-html5-map'); ?>">[?]</span><br />
            </div>
            <hr style="clear: both"/>
            <div style="float:left; min-width: 500px">
            <label><span class="title"><?php _e('Name:', 'usa2level-html5-map') ?> </span><input type="text" name="pointName" id="pointName" value=""/></label>
            <span class="tipsy-q" original-title="<?php esc_attr_e('This name will be show when mouse will be over this point', 'usa2level-html5-map'); ?>">[?]</span><br />
            <label><span class="title"><?php _e('Short name:', 'usa2level-html5-map') ?> </span><input type="text" name="pointShortname" id="pointShortname" value="" /></label>
            <span class="tipsy-q" original-title="<?php esc_attr_e('This name will be show near point on the map', 'usa2level-html5-map'); ?>">[?]</span><br />
            </div>
            <div style="float:left; min-width: 500px">
            <label><span class="title"><?php _e('Text position:', 'usa2level-html5-map') ?></span><select name="pointTextPos" id="pointTextPos" style=" width: 190px">
                <option value="left-top"><?php _e('Left Top', 'usa2level-html5-map') ?></option>
                <option value="left-middle"><?php _e('Left Middle', 'usa2level-html5-map') ?></option>
                <option value="left-bottom"><?php _e('Left Bottom', 'usa2level-html5-map') ?></option>
                <option value="middle-top"><?php _e('Center Top', 'usa2level-html5-map') ?></option>
                <option value="middle-middle"><?php _e('Center Middle', 'usa2level-html5-map') ?></option>
                <option value="middle-bottom"><?php _e('Center Bottom', 'usa2level-html5-map') ?></option>
                <option value="right-top"><?php _e('Right Top', 'usa2level-html5-map') ?></option>
                <option value="right-middle"><?php _e('Right Middle', 'usa2level-html5-map') ?></option>
                <option value="right-bottom"><?php _e('Right Bottom', 'usa2level-html5-map') ?></option>
            </select></label>
            <span class="tipsy-q" original-title="<?php esc_attr_e('Shortname position relative to the point', 'usa2level-html5-map'); ?>">[?]</span>
            <br/>
            <label><span class="title"><?php _e('Font size:', 'usa2level-html5-map'); ?></span><input type="number" name="pointFS" id="pointFS" min="3" max="20" style="width: 190px"/> px
            <span class="tipsy-q" original-title='<?php _e('Font size of the shortname displayed near the point.', 'usa2level-html5-map'); ?>'>[?]</span>&nbsp;&nbsp;&nbsp;</label>
            <label for="pointFSDef"><input name="pointFSDef" id="pointFSDef" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
            <br />
            </div>
            <div style="clear: both"></div>

            <hr/>
            <label><span class="title"><?php _e("Tooltip:", "usa2level-html5-map") ?></span></label><br/>
            <?php usa2level_map_plugin_wp_editor_for_tooltip('', 'pointComment', 'pointComment'); ?>
            <span class="title"><?php _e('Image URL:', 'usa2level-html5-map'); ?> </span>
            <input onclick="imageFieldId = this.id; tb_show('Image', 'media-upload.php?type=image&tab=library&TB_iframe=true');" class="" type="text" id="pointImage" name="pointImage" value="" />
            <span style="font-size: 10px; cursor: pointer;" onclick="jQuery('#pointImage').val('')"><?php _e('clear', 'usa2level-html5-map'); ?></span>
            <span class="tipsy-q" original-title="<?php esc_attr_e('The path to file of the image to display in a popup', 'usa2level-html5-map'); ?>">[?]</span><br />
            <hr/>

            <div style="float:left; max-width: 120px">
                <span class="title" style="width: 120px"><?php _e('Property', 'usa2level-html5-map'); ?> </span>
            </div>
            <div style="float:left; min-width: 240px">
                <span class="title" style="width: 120px"><?php _e('Normal color', 'usa2level-html5-map'); ?> </span>
            </div>
            <div style="float:left; min-width: 240px">
                <span class="title" style="width: 120px"><?php _e('Hover color', 'usa2level-html5-map'); ?> </span>
            </div>
            <div style="float:left; min-width: 240px">
                <span class="title" style="width: 120px"><?php _e('Selected color', 'usa2level-html5-map'); ?> </span>
            </div>
            <div style="clear: both"></div>
            <br>

            <div style="float:left; max-width: 120px; width: 25%">
            <span class="title" style="width:120xp"><?php _e('Point color:', 'usa2level-html5-map'); ?> </span>
            </div>
            <div style="float:left; min-width: 240px; width: 25%">
            <input class="color colorSimple" type="text" name="pointColor" id="pointColor" value="" style="background-color: white"  />
            <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
            <label for="colorDef"><input name="colorDef" id="colorDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
            <br />
            </div>
            <div style="float:left; min-width: 240px; width: 25%">
            <input class="color colorOver" type="text" name="pointColorOver" id="pointColorOver" style="background-color: white"  />
            <span class="tipsy-q" original-title='<?php _e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
            <label for="colorOverDef"><input name="colorOverDef" id="colorOverDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
            <br />
            </div>
            <div style="float:left; min-width: 240px; width: 25%">
            <input class="color colorOver" type="text" name="pointColorSelected" id="pointColorSelected" style="background-color: white"  />
            <span class="tipsy-q" original-title='<?php _e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
            <label for="colorSelectedDef"><input name="colorSelectedDef" id="colorSelectedDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
            <br />
            </div>
            <div style="clear: both"></div>
            <div style="border-top: 1px solid #ddd; margin-top: 10px">
                <label style="position: relative; top: -13px; background: white"><a href="javascript:void(0);" onclick="show_more_colors(this.innerHTML.indexOf('+')!==-1)"><?php echo sprintf(__("More color settings [%s]", "usa2level-html5-map"), "<span>+</span>") ?></a></label>
                <div id="pointColorsWrapp">
                    <div style="float:left; max-width: 120px; width: 25%">
                    <span class="title" style="width: 120px"><?php _e('Border color:', 'usa2level-html5-map'); ?> </span>
                    <br /><br />
                    <span class="title" style="width: 120px"><?php _e('Name color:', 'usa2level-html5-map'); ?> </span>
                    <br /><br />
                    <span class="title" style="width: 120px"><?php _e('Name stroke color:', 'usa2level-html5-map'); ?> </span>
                    <br /><br />
                    </div>

                    <div style="float:left; min-width: 240px; width: 25%">
                    <input class="color colorSimple" type="text" name="borderColor" id="borderColor" value="" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="borderColorDef"><input name="borderColorDef" id="borderColorDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    <input class="color colorSimple" type="text" name="nameColor" id="nameColor" value="" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="nameColorDef"><input name="nameColorDef" id="nameColorDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    <input class="color colorSimple" type="text" name="nameStrokeColor" id="nameStrokeColor" value="" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php esc_attr_e('The color of a point.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="nameStrokeColorDef"><input name="nameStrokeColorDef" id="nameStrokeColorDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    </div>

                    <div style="float:left; min-width: 240px; width: 25%">
                    <input class="color colorOver" type="text" name="borderColorOver" id="borderColorOver" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php _e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="borderColorOverDef"><input name="borderColorOverDef" id="borderColorOverDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    <input class="color colorOver" type="text" name="nameColorOver" id="nameColorOver" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php _e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="nameColorOverDef"><input name="nameColorOverDef" id="nameColorOverDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    <input class="color colorOver" type="text" name="nameStrokeColorOver" id="nameStrokeColorOver" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php _e('The color of a point when the mouse cursor is over it.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="nameStrokeColorOverDef"><input name="nameStrokeColorOverDef" id="nameStrokeColorOverDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    </div>
                    
                    <div style="float:left; min-width: 240px; width: 25%">
                    <input class="color colorOver" type="text" name="borderColorSelected" id="borderColorSelected" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php _e('The color of a point when it is selected.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="borderColorSelectedDef"><input name="borderColorSelectedDef" id="borderColorSelectedDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    <input class="color colorOver" type="text" name="nameColorSelected" id="nameColorSelected" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php _e('The color of a point when it is selected.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="nameColorSelectedDef"><input name="nameColorSelectedDef" id="nameColorSelectedDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    <input class="color colorOver" type="text" name="nameStrokeColorSelected" id="nameStrokeColorSelected" style="background-color: white"  />
                    <span class="tipsy-q" original-title='<?php _e('The color of a point when it is selected.', 'usa2level-html5-map'); ?>'>[?]</span><div class="flamap-colorpicker"></div>
                    <label for="nameStrokeColorSelectedDef"><input name="nameStrokeColorSelectedDef" id="nameStrokeColorSelectedDef" class="colorOverCh" type="checkbox" /> <?php _e('Use default', 'usa2level-html5-map'); ?></label>
                    <br />
                    </div>
                </div>
            </div>
            <hr style="clear: both"/>
            <span class="title"><?php _e('On click action:', 'usa2level-html5-map'); ?> </span>
            <label><input type="radio" name="clickaction" id="ca-nothing" value="nothing" checked="checked" autocomplete="off"/> <?php _e('nothing', 'usa2level-html5-map') ?></label>&nbsp;&nbsp;&nbsp;
            <label><input type="radio" name="clickaction" id="ca-url"     value="url"  autocomplete="off"/> <?php _e('open link', 'usa2level-html5-map') ?></label>&nbsp;&nbsp;&nbsp;
            <label><input type="radio" name="clickaction" id="ca-info"    value="info" autocomplete="off"/> <?php _e('show additional information', 'usa2level-html5-map') ?></label>&nbsp;&nbsp;&nbsp;
            <br>
            <div id="action-url" style="display: none">
            <hr style="clear: both"/>
                <span class="title"><?php _e('URL:', 'usa2level-html5-map'); ?> </span><input style="width: 270px;" class="" type="text" name="pointURL" id="pointURL" value="" />
                <span class="tipsy-q" original-title="<?php esc_attr_e('Open url on click (if specified)', 'usa2level-html5-map'); ?>">[?]</span></br>
                <span class="title"> </span>
                <label for="pointURLNW"><input name="pointURLNW" id="pointURLNW" class="" type="checkbox" /> <?php _e('Open url in a new window', 'usa2level-html5-map'); ?></label><br>
                <span class="title"> </span>
                <label for="pointURLTarget"><?php _e('Target for new window:', 'usa2level-html5-map'); ?> <input name="pointURLTarget" id="pointURLTarget" type="text">
            </div>
            <div id="action-info" style="display: none">
            <hr style="clear: both"/>
            <span class="title"><?php _e('Description:', 'usa2level-html5-map'); ?> <span class="tipsy-q" original-title="<?php esc_attr_e('The description is displayed to the right of the map and contains contacts or some other additional information', 'usa2level-html5-map'); ?>">[?]</span> </span>
            <?php wp_editor('', 'pointAddInfo', $mce_options); ?>
            </div>
            <div id="editorButtons"></div>
        </div>
    </fieldset>
    <link rel='stylesheet' href='<?php echo $dir ?>css/map.css'>
    <script type='text/javascript' src='<?php echo $dir ?>lib/raphael.js'></script>
    <script type='text/javascript' src='<?php echo $dir ?>lib/map.js'></script>

    <script>
        var map_cfg = {

        mapWidth        : 0,
        mapHeight       : 0,

        shadowAllow     : false,

        iOSbehavior     : <?php echo $doptions['map']['iOSbehavior']; ?>,

        borderColor     : "<?php echo $doptions['map']['borderColor']; ?>",
        borderColorOver     : "<?php echo $doptions['map']['borderColorOver']; ?>",

        nameColor       : "<?php echo $doptions['map']['nameColor']; ?>",
        nameColorOver   : "<?php echo $doptions['map']['nameColorOver']; ?>",
        nameStrokeColor     : "<?php echo $doptions['map']['nameStrokeColor']; ?>",
        nameStrokeColorOver : "<?php echo $doptions['map']['nameStrokeColorOver']; ?>",
        nameStrokeWidth     : "<?php echo $doptions['map']['nameStrokeWidth']; ?>",
        nameFontSize        : "<?php echo $map_options['map']['nameFontSize'].'px'; ?>",
        nameFontFamily      : "<?php echo usa2level_map_plugin_escape_fonts($map_options['map']['nameFontFamily'], 'Arial, sans-serif'); ?>",

        pointColor            : "<?php echo $map_options['map']['pointColor']?>",
        pointColorOver        : "<?php echo $map_options['map']['pointColorOver']?>",
        pointColorSelected        : "<?php echo $map_options['map']['pointColorSelected']?>",
        pointBorderColor        : "<?php echo $map_options['map']['pointBorderColor']?>",
        pointBorderColorOver    : "<?php echo $map_options['map']['pointBorderColorOver']?>",
        pointBorderColorSelected    : "<?php echo $map_options['map']['pointBorderColorSelected']?>",
        pointNameColor        : "<?php echo $map_options['map']['pointNameColor']?>",
        pointNameColorOver    : "<?php echo $map_options['map']['pointNameColorOver']?>",
        pointNameColorSelected    : "<?php echo $map_options['map']['pointNameColorSelected']?>",
        pointNameStrokeColor        : "<?php echo $map_options['map']['pointNameStrokeColor']?>",
        pointNameStrokeColorOver    : "<?php echo $map_options['map']['pointNameStrokeColorOver']?>",
        pointNameStrokeColorSelected    : "<?php echo $map_options['map']['pointNameStrokeColorSelected']?>",
        pointNameFontSize    : "<?php echo intval($map_options['map']['pointNameFontSize']).'px'?>",
        pointNameFontFamily    : "<?php echo usa2level_map_plugin_escape_fonts($map_options['map']['pointNameFontFamily'] ? $map_options['map']['pointNameFontFamily'] : $map_options['map']['nameFontFamily'], 'Arial, sans-serif'); ?>",

        backButtonTitle : false,
        useInfoPanel    : false,
        allowStateSelection : false,
        pathToJSON:     '<?php echo get_site_url() . "/?map_id=$map_id&m=p&usa2levelhtml5map_cont_data="; ?>',
        nameStroke      : <?php echo $doptions['map']['nameStroke']?'true':'false'; ?>,
        nameStrokeColor : "<?php echo $doptions['map']['nameStrokeColor']; ?>",
        ignoreLinks     : true
        };
<?php
    if (file_exists($params_file = dirname(__FILE__).'/static/paths.json')) {
        echo "map_cfg.map_params = ".file_get_contents($params_file).";\n";
    }
?>
        var map = new FlaMap(map_cfg);
        var activePoint = null;
        var editorSettings = <?php echo json_encode($editorSettings); ?>;

        function showEditor(title, buttons) {
            jQuery('#editorButtons').html('');
            if (buttons && buttons.length) {
                for (var i = 0; i < buttons.length; i++) {
                    (function (bt) {
                        jQuery('#editorButtons').append(jQuery('<button type="button"></button>').button({
                            text: bt.text,
                            label: bt.text,
                            icons: bt.icons
                        }).click(bt.click));
                    })(buttons[i]);
                }
            }
            jQuery('#pointEditor > legend').text(title);
            jQuery('#pointEditor').show();
            jQuery('#submit').prop('disabled', true);
            jQuery("html, body").animate({ scrollTop: jQuery('#pointEditor').offset().top - 40 }, 300);
        }
        function hideEditor() {
            jQuery('#pointEditor').hide();
            jQuery('#submit').prop('disabled', false);
        }
        jQuery(function($){
            var btnAdd = {
                'text': '<?php _e("Add", "usa2level-html5-map"); ?>',
                'icons': {
                    'primary': 'ui-icon-plus'
                },
                'click' : function() {
                    var x = parseInt(pX.val());
                    var y = parseInt(pY.val());
                    if (isNaN(x)) x = 0;
                    if (isNaN(y)) y = 0;

                    var radius = parseInt(pR.val() < 0 ? 0 : (pR.val() > <?php echo $maxRadius ?> ? <?php echo $maxRadius ?> : pR.val()));
                    if ( ! (radius || pSN.val()))
                        return alert('<?php _e('You cannot set radius to 0 without shortname', 'usa2level-html5-map'); ?>');

                    var p = map.addPoint(x, y, pN.val(), null, pT.val());
                    var link, isnw, info = null, target = '_blank';
                    var act = $('input[name="clickaction"]:checked').val();
                    if (act == 'url') {
                        link = pU.val();
                        isnw = pUNW.prop('checked') ? true : false;
                        target = pUT.val();
                    } else if (act == 'info') {
                        link = 'javascript:usa2levelhtml5map_map_set_state_text("'+p+'")';
                        info = editorGet();
                    } else {
                        link = null;
                    }

                    var attrs = {
                        shortname:          pSN.val(),
                        popup:              tooltipEditorGet(),
                        image:              pImg.val(),
                        textPos:            editorSettings.textPosition = pTP.val(),
                        radius:             editorSettings.radius = radius,
                        color:              editorSettings.color = uDC.prop('checked') ? null : pC.val(),
                        color2:             editorSettings.colorOver = uDCO.prop('checked') ? null : pCO.val(),
                        color3:             editorSettings.colorSelected = uDCS.prop('checked') ? null : (pCS.val() ? pCS.val() : null),
                        borderColor:        editorSettings.borderColor = uBDC.prop('checked') ? null : pBC.val(),
                        borderColorOver:    editorSettings.borderColorOver = uBDCO.prop('checked') ? null : pBCO.val(),
                        borderColorSelected:editorSettings.borderColorSelected = uBDCS.prop('checked') ? null : (pBCS.val() ? pBCS.val() : null),
                        nameColor:          editorSettings.nameColor = uNDC.prop('checked') ? null : pNC.val(),
                        nameColorOver:      editorSettings.nameColorOver = uNDCO.prop('checked') ? null : pNCO.val(),
                        nameColorSelected:  editorSettings.nameColorSelected = uNDCS.prop('checked') ? null : (pNCS.val() ? pNCS.val() : null),
                        nameStrokeColor:    editorSettings.nameStrokeColor = uNSDC.prop('checked') ? null : pNSC.val(),
                        nameStrokeColorOver: editorSettings.nameStrokeColorOver = uNSDCO.prop('checked') ? null : pNSCO.val(),
                        nameStrokeColorSelected: editorSettings.nameStrokeColorSelected = uNSDCS.prop('checked') ? null : (pNSCS.val() ? pNSCS.val() : null),
                        url: link,
                        info: info,
                        isNewWindow: isnw,
                        target: target
                    };
                    if (uDFS.prop('checked')) {
                        attrs.fontSize = null;
                        editorSettings.nameFontSize = null;
                    } else {
                        var fs = parseInt(pFS.val());
                        fs = fs < 3 ? 3 : (fs > 20 ? 20 : fs);
                        attrs.fontSize = fs+'px';
                        editorSettings.nameFontSize = fs;
                    }
                    map.setPointAttr(p, attrs);
                    //$(this).dialog('close');
                    hideEditor();
                    on_point_saved();
                }
            };
            var btnSave = {
                'text': '<?php _e("Apply", "usa2level-html5-map"); ?>',
                'icons': {
                    'primary': 'ui-icon-save'
                },
                'click' : function() {
                    var x = parseInt(pX.val());
                    var y = parseInt(pY.val());
                    if (isNaN(x)) x = 0;
                    if (isNaN(y)) y = 0;
                    var link, isnw, info = null, target = null;
                    var act = $('input[name="clickaction"]:checked').val();
                    if (act == 'url') {
                        link = pU.val();
                        isnw = pUNW.prop('checked') ? true : false;
                    } else if (act == 'info') {
                        link = 'javascript:usa2levelhtml5map_map_set_state_text("'+activePoint+'")';
                        info = editorGet();
                    } else {
                        link = null;
                    }
                    target = pUT.val();

                    var radius = parseInt(pR.val() < 0 ? 0 : (pR.val() > <?php echo $maxRadius ?> ? <?php echo $maxRadius ?> : pR.val()));
                    if ( ! (radius || pSN.val()))
                        return alert('<?php _e('You cannot set radius to 0 without shortname', 'usa2level-html5-map'); ?>');

                    var attrs = {
                        x: x,
                        y: y,
                        radius:             editorSettings.radius = radius,
                        name:               pN.val(),
                        shortname:          pSN.val(),
                        popup:              tooltipEditorGet(),
                        image:              pImg.val(),
                        textPos:            editorSettings.textPosition = pTP.val(),
                        color:              editorSettings.color = uDC.prop('checked') ? null : pC.val(),
                        color2:             editorSettings.colorOver = uDCO.prop('checked') ? null : pCO.val(),
                        color3:             editorSettings.colorSelected = uDCS.prop('checked') ? null : (pCS.val() ? pCS.val() : null),
                        borderColor:        editorSettings.borderColor = uBDC.prop('checked') ? null : pBC.val(),
                        borderColorOver:    editorSettings.borderColorOver = uBDCO.prop('checked') ? null : pBCO.val(),
                        borderColorSelected:editorSettings.borderColorSelected = uBDCS.prop('checked') ? null : (pBCS.val() ? pBCS.val() : null),
                        nameColor:          editorSettings.nameColor = uNDC.prop('checked') ? null : pNC.val(),
                        nameColorOver:      editorSettings.nameColorOver = uNDCO.prop('checked') ? null : pNCO.val(),
                        nameColorSelected:  editorSettings.nameColorSelected = uNDCS.prop('checked') ? null : (pNCS.val() ? pNCS.val() : null),
                        nameStrokeColor:    editorSettings.nameStrokeColor = uNSDC.prop('checked') ? null : pNSC.val(),
                        nameStrokeColorOver: editorSettings.nameStrokeColorOver = uNSDCO.prop('checked') ? null : pNSCO.val(),
                        nameStrokeColorSelected: editorSettings.nameStrokeColorSelected = uNSDCS.prop('checked') ? null : (pNSCS.val() ? pNSCS.val() : null),
                        url: link,
                        info: info,
                        isNewWindow: isnw,
                        target: target
                    };

                    if (uDFS.prop('checked')) {
                        attrs.fontSize = null;
                        editorSettings.nameFontSize = null;
                    } else {
                        var fs = parseInt(pFS.val());
                        fs = fs < 3 ? 3 : (fs > 20 ? 20 : fs);
                        attrs.fontSize = fs+'px';
                        editorSettings.nameFontSize = fs;
                    }
                    map.setPointAttr(activePoint, attrs);
                    //$(this).dialog('close');
                    hideEditor();
                    activePoint = null;
                    on_point_saved();
                }
            };
            var btnDelete = {
                'text': '<?php _e("Delete", "usa2level-html5-map"); ?>',
                'icons': {
                    'primary': 'ui-icon-delete'
                },
                'click' : function() {
                    var name = map.fetchPointAttr(activePoint, 'name');
                    if (confirm('<?php _e("Are you sure you want to delete point", "usa2level-html5-map") ?> '+name)) {
                        map.deletePoint(activePoint);
                        activePoint = null;
                        //$(this).dialog('close');
                        hideEditor();
                    }
                }
            };
            var btnClose = {
                'text': '<?php _e("Cancel", "usa2level-html5-map"); ?>',
                'icons': {
                    'primary': 'ui-icon-close'
                },
                'click' : function() {
                    //$(this).dialog('close');
                    hideEditor();
                }
            };
            map.draw('map_container');
            <?php if ($orig_states): ?>
            var sts = [<?php echo implode(', ', array_map('usa2level_map_plugin_quote_str', $orig_states)); ?>];
            map.on('loaded', function () {
                var st;
                if (st = sts.shift())
                    map.openState(st);
            });
            <?php endif; ?>
            map.on('dblclick', function(ev, sid, map){
                //dlg.dialog('open');
                if (sid && map.stateHasPoint(sid)) {
                    var p = map.statePointCfg(sid);
                    pX.val(p.x);
                    pY.val(p.y);
                    pN.val(p.name);
                    pSN.val(p.shortname);
                    pR.val(p.radius);
                    pU.val('http://');
                    pT.val(p.pointType).prop('disabled', true);
                    var act = 'nothing';
                    editorSet('');
                    if ((p.url && /^javascript:usa2levelhtml5map_map_set_state_text/.test(p.url)) || p.url == '#info') {
                        act = 'info';
                        editorSet(p.info?p.info:'');
                    }
                    else if (p.url)
                        act = 'url';
                    $('#ca-'+act).prop('checked', true).click();
                    pU.val(act == 'url' && p.url ? p.url : 'http://');
                    pTP.val(p.textPos ? p.textPos : 'right-middle');
                    pUNW.prop('checked', p.isNewWindow ? true : false);
                    pUT.val(p.target ? p.target : '_blank');
                    /*dlg.dialog('option', {
                        'title': '<?php _e("Edit point: %s", "usa2level-html5-map") ?>'.replace('%s', p.name),
                        'buttons': [btnSave, btnDelete, btnClose]
                    });*/
                    showEditor('<?php _e("Edit point: %s", "usa2level-html5-map") ?>'.replace('%s', p.name), [btnSave, btnDelete, btnClose]);
                    tooltipEditorSet(p.popup);
                    pImg.val(p.image ? p.image : '');
                    show_comment(!!p.popup);

                    if (p.color) {
                        uDC.prop('checked', false);
                        pC.val(p.color).css('backgroundColor', p.color).prop('disabled', false);
                    } else {
                        uDC.prop('checked', true);
                        pC.val(dpC.val()).css('backgroundColor', dpC.val()).prop('disabled', true);
                    }
                    if (p.color2) {
                        uDCO.prop('checked', false);
                        pCO.val(p.color2).css('backgroundColor', p.color2).prop('disabled', false);
                    } else {
                        uDCO.prop('checked', true);
                        pCO.val(dpCO.val()).css('backgroundColor', dpCO.val()).prop('disabled', true);
                    }
                    if (p.color3) {
                        uDCS.prop('checked', false);
                        pCS.val(p.color3).css('backgroundColor', p.color3).prop('disabled', false);
                    } else {
                        uDCS.prop('checked', true);
                        pCS.val(dpCS.val()).css('backgroundColor', dpCS.val()).prop('disabled', true);
                    }

                    var smc = false;
                    if (p.borderColor) {
                        smc = true;
                        uBDC.prop('checked', false);
                        pBC.val(p.borderColor).css('backgroundColor', p.borderColor).prop('disabled', false);
                    } else {
                        uBDC.prop('checked', true);
                        pBC.val(dpBC.val()).css('backgroundColor', dpBC.val()).prop('disabled', true);
                    }
                    if (p.borderColorOver) {
                        smc = true;
                        uBDCO.prop('checked', false);
                        pBCO.val(p.borderColorOver).css('backgroundColor', p.borderColorOver).prop('disabled', false);
                    } else {
                        uBDCO.prop('checked', true);
                        pBCO.val(dpBCO.val()).css('backgroundColor', dpBCO.val()).prop('disabled', true);
                    }
                    if (p.borderColorSelected) {
                        smc = true;
                        uBDCS.prop('checked', false);
                        pBCS.val(p.borderColorSelected).css('backgroundColor', p.borderColorSelected).prop('disabled', false);
                    } else {
                        uBDCS.prop('checked', true);
                        pBCS.val(dpBCS.val()).css('backgroundColor', dpBCS.val()).prop('disabled', true);
                    }

                    if (p.nameColor) {
                        smc = true;
                        uNDC.prop('checked', false);
                        pNC.val(p.nameColor).css('backgroundColor', p.nameColor).prop('disabled', false);
                    } else {
                        uNDC.prop('checked', true);
                        pNC.val(dpNC.val()).css('backgroundColor', dpNC.val()).prop('disabled', true);
                    }
                    if (p.nameColorOver) {
                        smc = true;
                        uNDCO.prop('checked', false);
                        pNCO.val(p.nameColorOver).css('backgroundColor', p.nameColorOver).prop('disabled', false);
                    } else {
                        uNDCO.prop('checked', true);
                        pNCO.val(dpNCO.val()).css('backgroundColor', dpNCO.val()).prop('disabled', true);
                    }
                    if (p.nameColorSelected) {
                        smc = true;
                        uNDCS.prop('checked', false);
                        pNCS.val(p.nameColorSelected).css('backgroundColor', p.nameColorSelected).prop('disabled', false);
                    } else {
                        uNDCS.prop('checked', true);
                        pNCS.val(dpNCS.val()).css('backgroundColor', dpNCS.val()).prop('disabled', true);
                    }

                    if (p.nameStrokeColor) {
                        smc = true;
                        uNSDC.prop('checked', false);
                        pNSC.val(p.nameStrokeColor).css('backgroundColor', p.nameStrokeColor).prop('disabled', false);
                    } else {
                        uNSDC.prop('checked', true);
                        pNSC.val(dpNSC.val()).css('backgroundColor', dpNSC.val()).prop('disabled', true);
                    }
                    if (p.nameStrokeColorOver) {
                        smc = true;
                        uNSDCO.prop('checked', false);
                        pNSCO.val(p.nameStrokeColorOver).css('backgroundColor', p.nameStrokeColorOver).prop('disabled', false);
                    } else {
                        uNSDCO.prop('checked', true);
                        pNSCO.val(dpNSCO.val()).css('backgroundColor', dpNSCO.val()).prop('disabled', true);
                    }
                    if (p.nameStrokeColorSelected) {
                        smc = true;
                        uNSDCS.prop('checked', false);
                        pNSCS.val(p.nameStrokeColorSelected).css('backgroundColor', p.nameStrokeColorSelected).prop('disabled', false);
                    } else {
                        uNSDCS.prop('checked', true);
                        pNSCS.val(dpNSCS.val()).css('backgroundColor', dpNSCS.val()).prop('disabled', true);
                    }

                    if (p.fontSize) {
                        pFS.val(parseInt(p.fontSize)).prop('disabled', false);
                        uDFS.prop('checked', false);
                    } else {
                        pFS.val(parseInt(map.mapConfig.pointNameFontSize)).prop('disabled', true);
                        uDFS.prop('checked', true);
                    }
                    /*show_more_colors(smc);*/
                    show_more_colors(false);

                    activePoint = sid;
                } else {
                    var useSavedState = iES.prop('checked') ? false : true;
                    var color;
                    pX.val(ev.onMapX);
                    pY.val(ev.onMapY);
                    pN.val('');
                    pSN.val('');
                    pU.val('http://');
                    pT.val('').prop('disabled', false);
                    pR.val((useSavedState && editorSettings.radius) ? editorSettings.radius : pDR.val());
                    pTP.val(useSavedState ? editorSettings.textPosition : 'right-middle');
                    tooltipEditorSet('');
                    pImg.val('');
                    show_comment(false);
                    pUNW.prop('checked', false);
                    pUT.val('_blank');
                    editorSet('');
                    $('#ca-nothing').prop('checked', true).click();

                    pC.val(color = (useSavedState && editorSettings.color) ? editorSettings.color : dpC.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.color) ? false : true);
                    uDC.prop('checked', (useSavedState && editorSettings.color) ? false : true);
                    pCO.val(color = (useSavedState && editorSettings.colorOver) ? editorSettings.colorOver : dpCO.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.colorOver) ? false : true);
                    uDCO.prop('checked', (useSavedState && editorSettings.colorOver) ? false : true);
                    pCS.val(color = (useSavedState && editorSettings.colorSelected) ? editorSettings.colorSelected : dpCS.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.colorSeletected) ? false : true);
                    uDCS.prop('checked', (useSavedState && editorSettings.colorSelected) ? false : true);

                    pBC.val(color = (useSavedState && editorSettings.borderColor) ? editorSettings.borderColor : dpBC.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.borderColor) ? false : true);
                    uBDC.prop('checked', (useSavedState && editorSettings.borderColor) ? false : true);
                    pBCO.val(color = (useSavedState && editorSettings.borderColorOver) ? editorSettings.borderColorOver : dpBCO.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.borderColorOver) ? false : true);
                    uBDCO.prop('checked', (useSavedState && editorSettings.borderColorOver) ? false : true);
                    pBCS.val(color = (useSavedState && editorSettings.borderColorSelected) ? editorSettings.borderColorSelected : dpBCS.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.borderColorSelected) ? false : true);
                    uBDCS.prop('checked', (useSavedState && editorSettings.borderColorSelected) ? false : true);

                    pNC.val(color = (useSavedState && editorSettings.nameColor) ? editorSettings.nameColor : dpNC.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.nameColor) ? false : true);
                    uNDC.prop('checked', (useSavedState && editorSettings.nameColor) ? false : true);
                    pNCO.val(color = (useSavedState && editorSettings.nameColorOver) ? editorSettings.nameColorOver : dpNCO.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.nameColorOver) ? false : true);
                    uNDCO.prop('checked', (useSavedState && editorSettings.nameColorOver) ? false : true);
                    pNCS.val(color = (useSavedState && editorSettings.nameColorSelected) ? editorSettings.nameColorSelected : dpNCS.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.nameColorSelected) ? false : true);
                    uNDCS.prop('checked', (useSavedState && editorSettings.nameColorSelected) ? false : true);

                    pNSC.val(color = (useSavedState && editorSettings.nameStrokeColor) ? editorSettings.nameStrokeColor : dpNSC.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.nameStrokeColor) ? false : true);
                    uNSDC.prop('checked', (useSavedState && editorSettings.nameStrokeColor) ? false : true);
                    pNSCO.val(color = (useSavedState && editorSettings.nameStrokeColorOver) ? editorSettings.nameStrokeColorOver : dpNSCO.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.nameStrokeColorOver) ? false : true);
                    uNSDCO.prop('checked', (useSavedState && editorSettings.nameStrokeColorOver) ? false : true);
                    pNSCS.val(color = (useSavedState && editorSettings.nameStrokeColorSelected) ? editorSettings.nameStrokeColorSelected : dpNSCS.val()).css('backgroundColor', color).prop('disabled', (useSavedState && editorSettings.nameStrokeColorSelected) ? false : true);
                    uNSDCS.prop('checked', (useSavedState && editorSettings.nameStrokeColorSelected) ? false : true);

                    if (useSavedState) {
                        /*show_more_colors(
                            editorSettings.color||editorSettings.colorOver||editorSettings.borderColor||editorSettings.borderColorOver||
                            editorSettings.nameColor||editorSettings.nameColorOver||editorSettings.nameStrokeColor||editorSettings.nameStrokeColorOver
                        );*/
                        show_more_colors(false);
                    } else {
                        show_more_colors(false);
                    }

                    pFS.val((useSavedState && editorSettings.nameFontSize) ? editorSettings.nameFontSize : parseInt(Math.min(20, Math.max(3, dpFS.val())))).prop('disabled', (useSavedState && editorSettings.nameFontSize) ? false : true);
                    uDFS.prop('checked', (useSavedState && editorSettings.nameFontSize) ? false : true);
                    /*dlg.dialog('option', {
                        'title': '<?php _e("Add new point", "usa2level-html5-map") ?>',
                        'buttons': [btnAdd, btnClose]
                    });*/
                    showEditor('<?php _e("Add new point", "usa2level-html5-map") ?>', [btnAdd, btnClose]);
                    activePoint = null;
                }
            });
            var lastX = 0, lastY = 0, is_moving = false;
            map.on('mousedown', function(ev, sid, map) { if (sid && map.stateHasPoint(sid)) {
                lastX = ev.onMapX;
                lastY = ev.onMapY;
                is_moving = sid;
                ev.stopPropagation();
            } });
            map.on('mouseup', function(ev, sid, map) {
                lastX = 0;
                lastY = 0;
                is_moving = false;
                });
            map.on('mousemove', function(ev, sid, map) {
                if (is_moving) {
                    var dx = ev.onMapX - lastX,
                        dy = ev.onMapY - lastY;
                    map.setPointAttr(is_moving, {
                        x: map.fetchPointAttr(is_moving, 'x')+dx,
                        y: map.fetchPointAttr(is_moving, 'y')+dy
                    });
                    lastX = ev.onMapX;
                    lastY = ev.onMapY;
                    ev.stopPropagation();
                }
            });
            var pX = $('#pointX');
            var pY = $('#pointY');
            var pT = $('#pointType');
            var pN = $('#pointName');
            var pSN = $('#pointShortname');

            var pC  = $('#pointColor');
            var pCO = $('#pointColorOver');
            var pCS = $('#pointColorSelected');
            var dpC  = $('#dPointColor');
            var dpCO = $('#dPointColorOver');
            var dpCS = $('#dPointColorSelected');
            var uDC  = $('#colorDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pC.prop('disabled', checked);
                if (checked)
                    pC.val(dpC.val()).css('backgroundColor', dpC.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'color')))
                    pC.val(ac).css('backgroundColor', ac);
            });
            var uDCO = $('#colorOverDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pCO.prop('disabled', checked);
                if (checked)
                    pCO.val(dpCO.val()).css('backgroundColor', dpCO.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'color2')))
                    pCO.val(ac).css('backgroundColor', ac);
            });
            var uDCS = $('#colorSelectedDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pCS.prop('disabled', checked);
                if (checked)
                    pCS.val(dpCS.val()).css('backgroundColor', dpCS.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'color3')))
                    pCS.val(ac).css('backgroundColor', ac);
            });

            var pBC  = $('#borderColor');
            var pBCO = $('#borderColorOver');
            var pBCS = $('#borderColorSelected');
            var dpBC  = $('#dPointBorderColor');
            var dpBCO = $('#dPointBorderColorOver');
            var dpBCS = $('#dPointBorderColorSelected');
            var uBDC  = $('#borderColorDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pBC.prop('disabled', checked);
                if (checked)
                    pBC.val(dpBC.val()).css('backgroundColor', dpBC.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'borderColor')))
                    pBC.val(ac).css('backgroundColor', ac);
            });
            var uBDCO = $('#borderColorOverDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pBCO.prop('disabled', checked);
                if (checked)
                    pBCO.val(dpBCO.val()).css('backgroundColor', dpBCO.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'borderColorOver')))
                    pBCO.val(ac).css('backgroundColor', ac);
            });
            var uBDCS = $('#borderColorSelectedDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pBCS.prop('disabled', checked);
                if (checked)
                    pBCS.val(dpBCS.val()).css('backgroundColor', dpBCS.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'borderColorSeletected')))
                    pBCS.val(ac).css('backgroundColor', ac);
            });

            var pNC  = $('#nameColor');
            var pNCO = $('#nameColorOver');
            var pNCS = $('#nameColorSelected');
            var dpNC  = $('#dPointNameColor');
            var dpNCO = $('#dPointNameColorOver');
            var dpNCS = $('#dPointNameColorSelected');
            var uNDC  = $('#nameColorDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pNC.prop('disabled', checked);
                if (checked)
                    pNC.val(dpNC.val()).css('backgroundColor', dpNC.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'nameColor')))
                    pNC.val(ac).css('backgroundColor', ac);
            });
            var uNDCO = $('#nameColorOverDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pNCO.prop('disabled', checked);
                if (checked)
                    pNCO.val(dpNCO.val()).css('backgroundColor', dpNCO.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'nameColorOver')))
                    pNCO.val(ac).css('backgroundColor', ac);
            });
            var uNDCS = $('#nameColorSelectedDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pNCS.prop('disabled', checked);
                if (checked)
                    pNCS.val(dpNCS.val()).css('backgroundColor', dpNCS.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'nameColorSelected')))
                    pNCS.val(ac).css('backgroundColor', ac);
            });

            var pNSC  = $('#nameStrokeColor');
            var pNSCO = $('#nameStrokeColorOver');
            var pNSCS = $('#nameStrokeColorSelected');
            var dpNSC  = $('#dPointNameStrokeColor');
            var dpNSCO = $('#dPointNameStrokeColorOver');
            var dpNSCS = $('#dPointNameStrokeColorSelected');
            var uNSDC  = $('#nameStrokeColorDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pNSC.prop('disabled', checked);
                if (checked)
                    pNSC.val(dpNSC.val()).css('backgroundColor', dpNSC.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'nameStrokeColor')))
                    pNSC.val(ac).css('backgroundColor', ac);
            });
            var uNSDCO = $('#nameStrokeColorOverDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pNSCO.prop('disabled', checked);
                if (checked)
                    pNSCO.val(dpNSCO.val()).css('backgroundColor', dpNSCO.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'nameStrokeColorOver')))
                    pNSCO.val(ac).css('backgroundColor', ac);
            });
            var uNSDCS = $('#nameStrokeColorSelectedDef').change(function() {
                var checked = $(this).prop('checked'), ac = null;
                pNSCS.prop('disabled', checked);
                if (checked)
                    pNSCS.val(dpNSCS.val()).css('backgroundColor', dpNSCS.val());
                else if (activePoint && (ac = map.fetchPointAttr(activePoint, 'nameStrokeColorSelected')))
                    pNSCS.val(ac).css('backgroundColor', ac);
            });

            var pR   = $('#pointRadius');
            var pDR  = $('#dPointRadius');
            var pTP  = $('#pointTextPos');
                pCmt = $('#pointComment');
            var pImg = $('#pointImage');
            pAI  = $('#pointAddInfo');
            var pFS  = $('#pointFS');
            var dpFS = $('#dPointFontSize');
            var uDFS = $('#pointFSDef').change(function() {
                pFS.prop('disabled', $(this).prop('checked') ? true : false);
            });
            var pU = $('#pointURL');
            var pUNW = $('#pointURLNW');
            var pUT = $('#pointURLTarget');
            /*var dlg = $('#point_cfg').dialog({
                'minWidth': 600,
                'width': '80%',
                'autoOpen': false,
                'dialogClass': 'usa2levelhtml5map-html5-map',
                'buttons': []
            });*/
            var iES = $('#ignoreES');
            $('input[name="clickaction"]').click(function(){
                $('#action-url, #action-info').hide();
                $('#action-'+$('input[name="clickaction"]:checked').val()).show();
            });
            try{
            if (typeof tinyMCE !== 'undefined') tinyMCE.execCommand('mceAddControl', true, 'pointAddInfo');
            } catch (e) { console.log(e) }
        });
        var pCmt;
        var pAI;
        function show_comment(show) {
            if (typeof show == 'undefined')
                show = true;
            var w = jQuery('#pointCommentWrapp');
            var p = w.prev().find('span');
            p.html(show ? '-' : '+');
            show ? w.show() : w.hide();
        }
        function show_more_colors(show) {
            if (typeof show == 'undefined')
                show = true;
            var w = jQuery('#pointColorsWrapp');
            var p = w.prev().find('span');
            p.html(show ? '-' : '+');
            show ? w.show() : w.hide();
        }
        function show_default_options(show) {
            if (typeof show == 'undefined')
                show = true;
            var w = jQuery('#pointDefOptionsWrapp');
            var p = w.prev().find('span');
            p.html(show ? '-' : '+');
            show ? w.show() : w.hide();
        }
        function editorSet(txt) {
            tinymce.editors.pointAddInfo ?
                tinymce.editors.pointAddInfo.setContent(txt) :
                pAI.val(txt);
        }
        function editorGet() {
            return tinymce.editors.pointAddInfo ?
                tinymce.editors.pointAddInfo.getContent() :
                pAI.val();
        }
        function tooltipEditorSet(txt) {
            if (jQuery('#wp-pointComment-wrap').hasClass('tmce-active') && tinyMCE.get('pointComment')) {
                tinyMCE.get('pointComment').setContent(txt);
            } else {
                pCmt.val(txt);
            }
        }
        function tooltipEditorGet() {
            if (jQuery('#wp-pointComment-wrap').hasClass('tmce-active') && tinyMCE.get('pointComment')) {
                return tinyMCE.get('pointComment').getContent();
            } else {
                return pCmt.val();
            }
        }
        var allowExit = true;
        function on_point_saved() {
            allowExit = false;
            jQuery('select[name^=continent_select]').prop('disabled', true);
        }

        window.onbeforeunload = function (e) {
        if (allowExit)
            return;

            e = e || window.event;

            // For IE and Firefox prior to version 4
            if (e) {
                e.returnValue = 'You have unsaved modifications. Are you sure you want to leave this page?';
            }

            // For Safari
            return 'You have unsaved modifications. Are you sure you want to leave this page?';
        };

    </script>
    <input type="hidden" name="act_type" value="usa2level-html5-map-points-save" />
    <input type="hidden" name="map_points"  id="map_points"  />
    <input type="hidden" name="points_info" id="points_info" />
    <input type="hidden" name="editor_settings" id="editor_settings" />
    <p class="submit">
        <input type="submit" value="<?php esc_attr_e('Save Changes', 'usa2level-html5-map'); ?>" class="button-primary" id="submit" name="submit" onclick="allowExit = true;" disabled>
        &nbsp;&nbsp;&nbsp;
        <label style="display: none"><input type="checkbox" name="clear_saved_state" /> <?php _e('Clear editor saved state'); ?></label>
    </p>
</form>
</div>
