<?php
/*
Plugin Name: Interactive 2 Level USA Map
Plugin URI: https://www.fla-shop.com
Description: High-quality 2 Level USA map plugin for WordPress.
Text Domain: usa2level-html5-map
Domain Path: /languages
Version: 2.7.2.3
Author: Fla-shop.com
Author URI: https://www.fla-shop.com
License:
*/

add_action('plugins_loaded', 'usa2level_map_plugin_load_domain' );
function usa2level_map_plugin_load_domain() {
    load_plugin_textdomain('usa2level-html5-map', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
}

if (isset($_REQUEST['action']) && $_REQUEST['action']=='usa2level-map-plugin-export') { usa2level_map_plugin_export(); }
if (isset($_REQUEST['action']) && $_REQUEST['action']=='usa2level-map-plugin-export-csv') {  usa2level_map_plugin_export_csv(); }

add_action('admin_menu', 'usa2level_map_plugin_menu');

function usa2level_map_plugin_menu() {

    add_menu_page(__('USA 2-level Map','usa2level-html5-map'), __('USA 2-level Map','usa2level-html5-map'), 'manage_options', 'usa2level-map-plugin-options', 'usa2level_map_plugin_options' );

    add_submenu_page('usa2level-map-plugin-options', __('General settings','usa2level-html5-map'), __('General settings','usa2level-html5-map'), 'manage_options', 'usa2level-map-plugin-options', 'usa2level_map_plugin_options');
    add_submenu_page('usa2level-map-plugin-options', __('Detailed settings','usa2level-html5-map'), __('Detailed settings','usa2level-html5-map'), 'manage_options', 'usa2level-map-plugin-states', 'usa2level_map_plugin_states');
    add_submenu_page('usa2level-map-plugin-options', __('Points settings','usa2level-html5-map'), __('Points settings','usa2level-html5-map'), 'manage_options', 'usa2level-map-plugin-points', 'usa2level_map_plugin_points');
    add_submenu_page('usa2level-map-plugin-options', __('Map Preview','usa2level-html5-map'), __('Map Preview','usa2level-html5-map'), 'manage_options', 'usa2level-map-plugin-view', 'usa2level_map_plugin_view');
    add_submenu_page('usa2level-map-plugin-options', __('Maps','usa2level-html5-map'), __('Maps list','usa2level-html5-map'), 'manage_options', 'usa2level-map-plugin-maps', 'usa2level_map_plugin_maps');

}

function usa2level_map_plugin_options() {
    include('editmainconfig.php');
}

function usa2level_map_plugin_states() {
    include('editstatesconfig.php');
}

function usa2level_map_plugin_points() {
    include('editpointsconfig.php');
}

function usa2level_map_plugin_maps() {
    include('mapslist.php');
}

function usa2level_map_plugin_view() {

    $all_options = get_site_option('usa2levelhtml5map_options', array());
    $options_keys = array_keys($all_options);
    $def_map_id = reset($options_keys);
    $map_id  = (isset($_REQUEST['map_id'])) ? intval($_REQUEST['map_id']) : $def_map_id;

?>

    <div class="wrap">
    <h2>Map Preview</h2>

    <script type="text/javascript">
        jQuery(function(){

            jQuery('select[name=map_id]').change(function() {
                location.href='admin.php?page=usa2level-map-plugin-view&map_id='+jQuery(this).val();
            });

        });
    </script>

    <br />

    <form method="POST" class="usa2levelhtml5map-html5-map" onsubmit="">
    <?php usa2level_map_plugin_map_selector('preview', $map_id, $all_options); ?>
    <br /><br />

    <div style="clear: both;"></div>

<?php
    usa2level_map_plugin_nav_tabs('view', $map_id);

    echo '<p>' . sprintf(__('Use shortcode <b>%s</b> for install this map', 'usa2level-html5-map'), '[usa2levelhtml5map id="'.$map_id.'"]') . '</p>';

    echo do_shortcode('<div style="width: 99%">[usa2levelhtml5map id="'.$map_id.'"]</div>');
    echo "</form></div>";
}

add_action('admin_init','usa2level_map_plugin_scripts');

function usa2level_map_plugin_scripts() {

    if (is_admin()) {

        wp_register_style('jquery-tipsy', plugins_url('/static/css/tipsy.css', __FILE__));
        wp_enqueue_style('jquery-tipsy');
        wp_enqueue_style('thickbox');
        wp_register_style('usa2level-html5-mapadm', plugins_url('/static/css/mapadm.css', __FILE__));
        wp_enqueue_style('usa2level-html5-mapadm');
        wp_enqueue_style('farbtastic');
        wp_enqueue_script('jquery-ui-core');
        wp_enqueue_script('jquery-ui-dialog');
        wp_enqueue_style('wp-jquery-ui-dialog');
        wp_enqueue_script('farbtastic');
        wp_enqueue_script('tiny_mce');
        wp_enqueue_script('thickbox');
        wp_register_script('jquery-tipsy', plugins_url('/static/lib/jquery.tipsy.js', __FILE__));
        wp_enqueue_script('jquery-tipsy');

    } else {

        wp_register_style('usa2level-html5-map-style', plugins_url('/static/css/map.css', __FILE__));
        wp_enqueue_style('usa2level-html5-map-style');
        wp_register_script('raphael', plugins_url('/static/lib/raphael.js', __FILE__));
        wp_enqueue_script('raphael');
        wp_register_script('usa2level-html5-map-js', plugins_url('/static/lib/map.js', __FILE__));
        wp_enqueue_script('usa2level-html5-map-js');
        wp_enqueue_script('jquery');

    }

}

add_action('wp_enqueue_scripts', 'usa2level_map_plugin_scripts_method');

function usa2level_map_plugin_scripts_method() {
    wp_enqueue_script('jquery');
}

function usa2level_map_plugin_content($attrs, $content = "") {

    $dir          = plugins_url('/static/', __FILE__);
    $siteURL      = get_site_url();

    $map_id       = isset($attrs['id']) ? $attrs['id'] : 0;
    $options      = get_site_option('usa2levelhtml5map_options', array());
    $options      = isset($options[$map_id]) ? $options[$map_id] : usa2level_map_plugin_map_defaults();
    $options      = $options['map'];
    $default_options = usa2level_map_plugin_map_defaults($options['name'], $map_id, true);
        foreach($default_options as $k => $v) if (!isset($options[$k])) $options[$k] = $v;

    $style = '';
    if($options['layoutType'] == 'fixed') {
        $style = "width: $options[mapWidth]px; height: $options[mapHeight]px";
    } else if ($options['layoutType'] == 'resp') {
        if (intval($options['maxWidth']))
            $style = "max-width: ".(preg_match('/\d$/', $options['maxWidth']) ? $options['maxWidth'].'px' : $options['maxWidth']);
        else
            $stye = "width: 100%";
    }

    $mapInit = "
        <div style='$style' class='usa2levelhtmlmap' id='htmlmap'></div>
        <div style='clear: both'></div>

        <link href='{$dir}css/map.css' rel='stylesheet' type='text/css'>
        <script type='text/javascript' src='{$dir}lib/raphael.js'></script>
        <script type='text/javascript' src='{$siteURL}/index.php?usa2levelmap_js_data=true&map_id={$map_id}'></script>
        <script type='text/javascript' src='{$dir}lib/map.js'></script>
        <script>
            function usa2levelhtml5map_map_clear_info(ev, sid, map) {
                jQuery('#usa2levelhtmlmapStateInfo').html('');
                map.addInfoPanel.innerHTML = '';
            }

            var map = new FlaMap(map_settings);
            map.drawOnDomReady('htmlmap', function () {
                map.addInfoPanel.innerHTML = map.mapConfig.defaultInfo;
            });
            
            var lastGlobalInfo = map.mapConfig.defaultInfo;

            map.on('push', function(ev, sid, map) {
                usa2levelhtml5map_map_clear_info(ev, sid, map);
                map.unselectAll();
                if (map.fetchStateAttr(sid, 'showInfo')) {
                    usa2levelhtml5map_map_set_state_text(sid, false, true);
                } else {
                    lastGlobalInfo = '';
                }
            });
            map.on('pop', function(ev, sid, map) {
                usa2levelhtml5map_map_clear_info(ev, sid, map);
                map.unselectAll();
                if (map.fetchStateAttr(sid, 'showInfo')) {
                    usa2levelhtml5map_map_set_state_text(sid, false, true);
                } else if (sid == '') {
                    setTimeout(function() {
                        map.addInfoPanel.innerHTML = lastGlobalInfo = map.mapConfig.defaultInfo;
                    }, 1);
                } else {
                    lastGlobalInfo = '';
                }
            });
            
            map.on('click', function(ev, sid, map) {
                usa2levelhtml5map_map_clear_info(ev, sid, map);
                if (map.fetchStateAttr(sid, 'showInfo')) {
                    usa2levelhtml5map_map_set_state_text(sid);
                } else if (map.selectedStates.length && map.selectedStates.indexOf(sid) !== -1) {
                    map.addInfoPanel.innerHTML = lastGlobalInfo;
                }
            });

            function usa2levelhtml5map_map_set_state_text(state, scroll, setAsGlobal) {
                scroll = scroll === undefined ? true : scroll;
                setAsGlobal = !!setAsGlobal;
                if (map.selectedStates.indexOf(state) !== -1) {
                    map.addInfoPanel.innerHTML = lastGlobalInfo;
                    return;
                }
                map.addInfoPanel.innerHTML = 'Loading...';
                jQuery('#usa2levelhtmlmapStateInfo').html('Loading...');
                jQuery.ajax({
                    type: 'POST',
                    url: '{$siteURL}/index.php?map_id={$map_id}&usa2levelmap_get_state_info='+state,
                    success: function(data, textStatus, jqXHR){
                        if (setAsGlobal) lastGlobalInfo = data;
                        map.addInfoPanel.innerHTML = data;"
                         . (($options['contentArea'] == 'bottom' AND $options['autoScrollToInfo']) ? "
                            if (scroll) jQuery(\"html, body\").animate({ scrollTop: jQuery(map.addInfoPanel).offset().top - ".$options['autoScrollOffset']." }, 1000);" : "") . "
                    },
                    dataType: 'text'
                });
            }
        </script>
    ";

    return $options['minimizeOutput'] ? preg_replace('/\s+/', ' ', $mapInit) : $mapInit;
}

add_shortcode( 'usa2levelhtml5map', 'usa2level_map_plugin_content' );


$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'usa2level_map_plugin_settings_link' );

function usa2level_map_plugin_settings_link($links) {
    $settings_link = '<a href="admin.php?page=usa2level-map-plugin-options">Settings</a>';
    array_push($links, $settings_link);
    return $links;
}

function usa2level_map_plugin_slugify($str) {
    if (function_exists('mb_strtolower')) {
        $str = mb_strtolower($str);
    } else {
        $str = strtolower($str);
    }
    return preg_replace('/[\W]+/u', '-', $str);
}

add_action( 'parse_request', 'usa2level_map_plugin_wp_request' );

function usa2level_map_plugin_wp_request($wp) {
    if( isset($_GET['usa2levelmap_js_data']) AND isset($_GET['map_id']) ) {
        $options    = get_site_option('usa2levelhtml5map_options', array());
        $map_id     = $_GET['map_id'];
        $options    = isset($options[$map_id]) ? $options[$map_id] : usa2level_map_plugin_map_defaults();
        $options    = $options['map'];
        $default_options = usa2level_map_plugin_map_defaults($options['name'], $map_id, true);
        foreach($default_options as $k => $v) if (!isset($options[$k])) $options[$k] = $v;
        $mapWidth          = $options['mapWidth'];
        $mapHeight         = $options['mapHeight'];
        $layoutType        = $options['layoutType'];
        $stateInfoArea     = $options['contentArea'];
        $contentWidth      = $options['contentWidth'];

        if ($layoutType == 'resp') {
            if ($stateInfoArea=='left' or $stateInfoArea=='right') {
                $mapWidth  = "'".$contentWidth."%'";
                $mapHeight = "'100%'";
            } else {
                $mapWidth  = "'100%'";
                $mapHeight = "'100%'";
            }
        }


        header('Content-Type: application/javascript');
        
        $info = $options['defaultAddInfo'];
        if (strcmp($info, strip_tags($info)))
                $info = nl2br($info);
            $info = apply_filters('the_content', $info);

       ?>
        $ = jQuery;

        var map_settings = {

            mapWidth: <?php echo $mapWidth; ?>,
            mapHeight: <?php echo $mapHeight; ?>,

            borderColor: '<?php echo $options['borderColor']; ?>',
            borderColorOver: '<?php echo $options['borderColorOver']; ?>',
            borderWidth: '<?php echo $options['borderWidth']; ?>',

            nameColor: '<?php echo $options['nameColor']; ?>',
            nameColorOver: '<?php echo $options['nameColorOver']; ?>',
            nameFontFamily: '<?php echo $options['nameFontFamily']; ?>',
            nameFontSize: '<?php echo $options['nameFontSize']; ?>',
            nameFontWeight: '<?php echo $options['nameFontWeight']; ?>',

            nameStroke: <?php echo $options['nameStroke'] ? 'true' : 'false'; ?>,
            nameStrokeColor: '<?php echo $options['nameStrokeColor']; ?>',
            nameStrokeColorOver: '<?php echo $options['nameStrokeColorOver']; ?>',
            nameStrokeWidth: <?php echo $options['nameStrokeWidth']; ?>,
            nameStrokeOpacity: <?php echo $options['nameStrokeOpacity']; ?>,

            pointColor: '<?php echo $options['pointColor'] ?>',
            pointColorOver: '<?php echo $options['pointColorOver'] ?>',
            pointNameColor: '<?php echo $options['pointNameColor'] ?>',
            pointNameColorOver: '<?php echo $options['pointNameColorOver'] ?>',
            pointNameFontFamily: '<?php echo $options['pointNameFontFamily'] ?>',
            pointNameFontSize: '<?php echo $options['pointNameFontSize'] ?>',
            pointNameFontWeight: '<?php echo $options['pointNameFontWeight'] ?>',
            pointNameStroke: <?php echo $options['nameStroke'] ? 'true' : 'false' ?>,
            pointNameStrokeColor: '<?php echo $options['pointNameStrokeColor'] ?>',
            pointNameStrokeColorOver: '<?php echo $options['pointNameStrokeColorOver'] ?>',
            pointBorderWidth: '<?php echo $options['pointBorderWidth'] ?>',
            pointBorderColor: '<?php echo $options['pointBorderColor'] ?>',
            pointBorderColorOver: '<?php echo $options['pointBorderColorOver'] ?>',

            pathToJSON: '<?php echo get_site_url() . "/?map_id=$map_id&usa2levelhtml5map_cont_data="; ?>',
            pathToStatic: '<?php echo plugins_url('/static/img/', __FILE__)?>',

            iOSbehavior: <?php echo $options['iOSbehavior']; ?>,
            backButtonTitle: '<?php echo $options['backButtonText'] ?>',
            disableCache: <?php echo $options['disableCache'] ? 'true' : 'false' ?>,

            useInfoPanel: true,
            infoPanelPosition: "<?php echo $stateInfoArea; ?>",
            defaultInfo: <?php echo json_encode($info); ?>

        };

        <?php
        exit;
    }

    if(isset($_GET['usa2levelhtml5map_cont_data']) AND isset($_GET['map_id'])) {
        $options    = get_site_option('usa2levelhtml5map_options', array());
        $map_id     = $_GET['map_id'];
        $options    = isset($options[$map_id]) ? $options[$map_id] : usa2level_map_plugin_map_defaults();
//         $linkProcessing = isset($options['map']['linkProcessing']) ? $options['map']['linkProcessing'] : false;
        $states_options    = $options['states'];

        $cfg_file   = $_GET['usa2levelhtml5map_cont_data'];
//         echo "<pre>".print_r($options['points'], 1)."</pre>";
        $points = (isset($options['points'][$cfg_file])) ? $options['points'][$cfg_file] : false;

        /*if (is_array($points)) {
            foreach ($points as &$d) {
                if ($linkProcessing and $d['url'] and strpos($d['url'], 'javascript') === false) {
                    preg_match_all('/\{(name|shortname|id)\}/', $d['url'], $matches, PREG_SET_ORDER);
                    if (count($matches)) foreach($matches as $m) {
                        $v = $m[1] == 'id' ? $id : $d[$m[1]];
                        if ($linkProcessing == 'slugify') {
                            $v = usa2level_map_plugin_slugify($v);
                        } else {
                            $v = urlencode($v);
                        }
                        $d['url'] = str_replace($m[0], $v, $d['url']);
                    }
                }
            }
            unset($d);
        }*/

        header('Content-type: application/json');
        $needsDefault = isset($_GET['m']) ? $_GET['m'] : false;

        if (!$needsDefault and isset($states_options[$cfg_file])) {
            $data = json_decode($states_options[$cfg_file], true);
            foreach ($data as $id => &$d) {
                if (isset($d['_hide_name']))
                    $d['name'] = '';
                if (isset($d['url']) and stripos($d['url'], "javascript:usa2levelhtml5map_map_set_state_text") !== false) {
                    unset($d['url']);
                    $d['showInfo'] = true;
                }
                /*if ($linkProcessing and $d['url'] and strpos($d['url'], 'javascript') === false) {
                    preg_match_all('/\{(name|shortname|id)\}/', $d['url'], $matches, PREG_SET_ORDER);
                    if (count($matches)) foreach($matches as $m) {
                        $v = $m[1] == 'id' ? $id : $d[$m[1]];
                        if ($linkProcessing == 'slugify') {
                            $v = usa2level_map_plugin_slugify($v);
                        } else {
                            $v = urlencode($v);
                        }
                        $d['url'] = str_replace($m[0], $v, $d['url']);
                    }
                }*/
            }
            if ($points)
                $data['points'] = $points;
            echo json_encode($data);
        }
        elseif (file_exists(dirname(__FILE__).'/static/data/'.$cfg_file)) {
            if ($needsDefault == 'p' and isset($states_options[$cfg_file])) {
                $data = json_decode(file_get_contents(dirname(__FILE__).'/static/data/'.$cfg_file), true);
                if ($data) foreach ($data as $id => &$d) {
                    $d['popup']     = '';
                    $d['url']       = '';
                    $d['allowOpen'] = false;
                }
                if ($points) {
                    foreach ($points as $pid => &$point) {
                        if (isset($options['info'][$pid]))
                            $point['info'] = $options['info'][$pid];
                    }
                    unset($point);
                    $data['points'] = $points;
                }
                echo json_encode($data);
            } else
                readfile(dirname(__FILE__).'/static/data/'.$cfg_file);
        }
        else
            echo "";

        exit;
    }

    if(isset($_GET['usa2levelmap_get_state_info'])) {
        $options    = get_site_option('usa2levelhtml5map_options', array());
        $map_id     = $_GET['map_id'];
        $options    = isset($options[$map_id]) ? $options[$map_id] : usa2level_map_plugin_map_defaults();
        $options    = $options['info'];
        $state_id   = $_GET['usa2levelmap_get_state_info'];

        if (isset($options[$state_id])) {
            $info = $options[$state_id];
            if (!strcmp($info, strip_tags($info)))
                $info = nl2br($info);
            echo apply_filters('the_content', $info);
        }
        else
            echo "";

        exit;
    }
}

function usa2level_map_plugin_map_defaults_load_continents(&$states, &$id2cfg, &$continents)
{
    $to_process = array();
    if($continents) {
        foreach($continents as $continent_id => $data) {
            if(isset($data['config']) AND $data['config'] != ''/* AND ! isset($states[$data['config']])*/ AND file_exists(dirname(__FILE__) . '/static/data/' . $data['config'])) {
                $configPath    = dirname(__FILE__) . '/static/data/' . $data['config'];
                $continentData = file_get_contents($configPath);
                $states[$data['config']] = $continentData;
                $id2cfg[$continent_id] = $data['config'];

                $continentData = json_decode($continentData, true);
                if ($continentData)
                    $to_process[] = $continentData;
            }
        }
    }
    foreach ($to_process as &$continentData) {
        usa2level_map_plugin_map_defaults_load_continents($states, $id2cfg, $continentData);
    }
}

function usa2level_map_plugin_fix_old_map(&$map_options)
{
    if (isset($map_options['id2cfg']))
        return FALSE;

    $initialStatesPath = dirname(__FILE__).'/static/data/main.cfg.js';
    $initialData       = file_get_contents($initialStatesPath);

    $states = array(
        'main.cfg.js'   => $initialData
    );

    $id2cfg = array();

    $initialData = json_decode($initialData, true);

    usa2level_map_plugin_map_defaults_load_continents($states, $id2cfg, $initialData);

    $map_options['id2cfg'] = $id2cfg;
    return TRUE;
}

function usa2level_map_plugin_map_defaults($name='New map', $map_id=0, $basicCfg=false) {
    $siteURL           = get_site_url();

    $defaults = array(
        'name'              => $name,
        'mapWidth'          => 500,
        'mapHeight'         => 380,
        'maxWidth'          => 980,
        'iOSbehavior'       => 2,
        'popupWidth'        => 250,
        'borderColor'       => "#ffffff",
        'borderColorOver'   => "#ffffff",
        'borderColorSelected'=> "#ffffff",
        'borderWidth'       => 0.5,
        'nameColor'         => "#ffffff",
        'nameColorOver'     => "#ffffff",
        'nameColorSelected' => "#ffffff",
        'nameFontSize'      => "8px",
        'nameFontWeight'    => "bold",
        'nameFontFamily'    => "",
        'nameStroke'        => false,
        'nameStrokeColor'   => '#000000',
        'nameStrokeColorOver' => '#000000',
        'nameStrokeColorSelected' => '#000000',
        'nameStrokeWidth'   => 1.5,
        'nameStrokeOpacity' => 0.5,

        'defaultPointRadius'    => 4,
        'pointColor'            => "#FFC480",
        'pointColorOver'        => "#DC8135",
        'pointColorSelected'    => "",
        'pointNameColor'        => "#000",
        'pointNameColorOver'    => "#222",
        'pointNameColorSelected'=> "",
        'pointNameFontFamily'   => '',
        'pointNameFontSize'     => "12",
        'pointNameFontWeight'   => "bold",
        'pointNameStroke'       => true,
        'pointNameStrokeColor'  => "#FFFFFF",
        'pointNameStrokeColorOver'  => "#FFFFFF",
        'pointNameStrokeColorSelected'  => "",
        'pointBorderWidth'      => 0.5,
        'pointBorderColor'      => "#ffffff",
        'pointBorderColorOver'  => "#eeeeee",
        'pointBorderColorSelected'  => "",

        'pathToJSON'        => $siteURL . "/?map_id=$map_id&usa2levelhtml5map_cont_data=",
        'statesInfoArea'    => "bottom",
        'layoutType'        => "resp",
        'contentWidth'      => "40",
        'contentArea'       => "bottom",
        'autoScrollToInfo'  => false,
        'autoScrollOffset'  => 0,
        'defaultAddInfo'    => '',
        'backButtonText'    => "back",
//         'linkProcessing'    => false,
        'minimizeOutput'    => true,
        'disableCache'      => false,
    );

    if ($basicCfg)
        return $defaults;

    $initialStatesPath = dirname(__FILE__).'/static/data/main.cfg.js';
    $initialData       = file_get_contents($initialStatesPath);
    $defaults['main_data'] = $initialData;

    $states = array(
        'main.cfg.js'   => $initialData
    );

    $id2cfg = array();

    $initialData = json_decode($initialData, true);

    usa2level_map_plugin_map_defaults_load_continents($states, $id2cfg, $initialData);

    return array(
        'map'       => $defaults,
        'states'    => $states,
        'id2cfg'    => $id2cfg,
        'info'      => array()
    );
}

function usa2level_map_plugin_mce_options($fieldName) {
    return array(
        //'media_buttons' => false,
        'textarea_rows' => 10,
        'textarea_name' => $fieldName
    );
}

register_activation_hook( __FILE__, 'usa2level_map_plugin_activation' );

function usa2level_map_plugin_activation() {

    add_site_option('usa2levelhtml5map_options', array(0 => usa2level_map_plugin_map_defaults('New map', 0)));
}

register_deactivation_hook( __FILE__, 'usa2level_map_plugin_deactivation' );

function usa2level_map_plugin_deactivation() {
    //usa2level_map_plugin_uninstall();
}

register_uninstall_hook( __FILE__, 'usa2level_map_plugin_uninstall' );

function usa2level_map_plugin_uninstall() {
    delete_site_option('usa2levelhtml5map_options');
}

function usa2level_map_plugin_wp_editor_for_tooltip($content, $name = 'tooltip', $id = 'tooltip_editor') {
    wp_editor($content, $id, array(
        'wpautop'       => 1,
        'media_buttons' => 1,
        'textarea_name' => $name,
        'textarea_rows' => 5,
        'tabindex'      => null,
        'editor_css'    => '',
        'editor_class'  => '',
        'teeny'         => 0,
        'dfw'           => 0,
        'tinymce'       => 1,
        'quicktags'     => 1,
        'drag_drop_upload' => false
    ));
}

function usa2level_map_plugin_get_csv_import_export_keys() {
    return array(
        'id'            => '',
        'name'          => '',
        'shortname'     => '',
        'color'         => '',
        'color2'        => '',
        'color3'        => '',
        'clickAction'    => '',
        'url'           => '',
        'target'        => '',
        'popup'         => '',
        'image'         => '',
        'info'          => '',
    );
}

function usa2level_map_plugin_export_csv() {
    if ( ! is_admin())
        return;
    remove_all_actions('wp_head');
    remove_all_actions('wp_footer');
    $importExportKeys = usa2level_map_plugin_get_csv_import_export_keys();

    $all_options = get_site_option('usa2levelhtml5map_options', array());
    $options_keys = array_keys($all_options);
    $def_map_id = reset($options_keys);

    $map_id = isset($_GET['map_id']) ? (int)$_GET['map_id'] : $def_map_id;

    $map_options = &$all_options[$map_id]; 
    $id2cfg_map = $map_options['id2cfg'];

    $field_delimiters = array(
        ',' => ',',
        ';' => ';',
        ':' => ':',
        'sp'=> ' ',
        'tb'=> "\t"
    );
    $text_delimiters = array(
        "'" => "'",
        '"' => '"',
        'n' => null
    );

    $fd = stripslashes($_REQUEST['field-delimiter']);
    $td = stripslashes($_REQUEST['text-delimiter']);
    if ( ! array_key_exists($fd, $field_delimiters)) {
        $fd = ',';
    }
    else {
        $fd = $field_delimiters[$fd];
    }
    if ( ! array_key_exists($td, $text_delimiters)) {
        $td = '"';
    }
    else {
        $td = $text_delimiters[$td];
    }

    $tmp_name = tempnam(sys_get_temp_dir(), 'mapcsv');
    $fh = fopen($tmp_name, 'w');
    $fields = array_keys($importExportKeys);
    fputcsv($fh, $fields, $fd, $td);
    foreach($map_options['states'] as $st_cfg_name => $st_params) {
        $st_params = json_decode($st_params, true);
        if ( ! is_array($st_params))
            continue;
        foreach ($st_params as $id => $params) {
            $params['id'] = $id;
            $params['info'] = isset($map_options['info'][$id]) ?$map_options['info'][$id] : '';
            $has_substates = isset($id2cfg_map[$id]);

            if(stripos($params['url'], "javascript:usa2levelhtml5map_map_set_state_text") !== false ) $params['clickAction'] = "info";
            elseif(trim($params['url']) != "") $params['clickAction'] = "link";
            elseif(($has_substates AND !isset($params['allowOpen'])) OR (isset($params['allowOpen']) AND $params['allowOpen'])) {
                $params['clickAction'] = (isset($params['showInfo']) AND $params['showInfo']) ? "substatesAndInfo" : "substates";
            }
            elseif ($has_substates AND isset($params['allowOpen']) AND !$params['allowOpen']) $params['clickAction'] = "none";
            else $params['clickAction'] = "";


            $data = array();
            foreach ($fields as $f)
                $data[$f] = isset($params[$f]) ? $params[$f] : $importExportKeys[$f];
            if ($params['clickAction'] == 'info') $data['url'] = '';
            if ($params['clickAction'] == 'url') {
                $params['target'] = $params['isNewWindow'] ? ($params['target'] ? $params['target'] : '_blank') : '';
            }
            fputcsv($fh, $data, $fd, $td);
        }
    }
    fclose($fh);
    header('Content-type: text/csv');
    header('Content-length: '.filesize($tmp_name));
    header('Connection: close');
    header('Content-Disposition: attachment; filename="usa2levelhtml5map-'.$map_id.'.csv";');
    readfile($tmp_name);
    unlink($tmp_name);
    exit;
}

function usa2level_map_plugin_export() {
    if ( ! is_admin())
        return;
    if ( ! isset($_REQUEST['maps']))
        return;

    $maps    = explode(',',$_REQUEST['maps']);
    $options = get_site_option('usa2levelhtml5map_options', array());

    foreach($options as $map_id => $option) {
        if (  !in_array($map_id, $maps)) {
            unset($options[$map_id]);
        }
    }

    if (count($options)>0) {
        $options = json_encode($options);

        header($_SERVER["SERVER_PROTOCOL"] . ' 200 OK');
        header('Content-Type: text/json');
        header('Content-Length: ' . (strlen($options)));
        header('Connection: close');
        header('Content-Disposition: attachment; filename="usa2levelhtml5maps.json";');
        echo $options;

        exit();
    }
}


function usa2level_map_plugin_import(&$errors) {
    $errors  = array();
    $siteURL = get_site_url();
    $csv_types = array('text/csv','text/comma-separated-values','application/vnd.ms-excel');
    if(is_uploaded_file($_FILES['import_file']["tmp_name"])) {

        if (in_array($_FILES['import_file']['type'], $csv_types))
        {
            $errors[] = sprintf(__('CSV import should be done on the "<a href="%s">Detailed settings</a>" tab', 'usa2level-html5-map'), "admin.php?page=usa2level-map-plugin-states");
            return false;
        }

        $hwnd = fopen($_FILES['import_file']["tmp_name"],'r');
        $data = fread($hwnd,filesize($_FILES['import_file']["tmp_name"]));
        fclose($hwnd);

        $def_settings = usa2level_map_plugin_map_defaults('New map', 0);
        $states_count = count($def_settings['states']);

        $data    = json_decode($data, true);
        if ($data)
        {
            $options = get_site_option('usa2levelhtml5map_options');

            foreach($data as $map_id => $map_data) {

                if (isset($map_data['map']) AND is_array($map_data['map']))
                {
                    $c = $options ? max(array_keys($options))+1 : 0;
                    $count = is_array($map_data['states']) ? count($map_data['states']) : -1;
                    if ($count != $states_count) {
                        $errors[] = sprintf(__("Failed to import '%s', looks it is a wrong map. $count - $states_count", 'usa2level-html5-map'), $map_data['name']);
                        continue;
                    }
                    $map_data['map']['pathToJSON'] = $siteURL . "/?map_id=$c&usa2levelhtml5map_cont_data=";
                    foreach ($map_data['states'] as &$st)
                        $st = preg_replace("/javascript:[\w_]+_set_state_text[^\(]*\(/", "javascript:usa2levelhtml5map_map_set_state_text(", $st);
                    unset($st);

                    usa2level_map_plugin_fix_old_map($map_data);

                    $options[] = $map_data;
                }

            }

            update_site_option('usa2levelhtml5map_options',$options);

            unlink($_FILES['import_file']["tmp_name"]);
        }
        else
        {
            $errors[] = __('Wrong file format!', 'usa2level-html5-map');
        }

    } else {
        $errors[] = __('File uploading error!', 'usa2level-html5-map');
    }
    return !count($errors);
}

function usa2level_map_plugin_import_csv(&$errors) {
    $types = array('text/csv','text/comma-separated-values','application/vnd.ms-excel');
    $json_types = array('application/json');
    $field_delimiters = array(
        ',' => ',',
        ';' => ';',
        ':' => ':',
        'sp'=> ' ',
        'tb'=> "\t"
    );
    $text_delimiters = array(
        "'" => "'",
        '"' => '"',
        'n' => null
    );
    $errors = array();

    if (! is_uploaded_file($_FILES['csv-file']['tmp_name']))
        $errors[] = __('File upload error!', 'usa2level-html5-map');
    else {
        if (in_array($_FILES['csv-file']['type'], $json_types)) {
            $errors[] = sprintf(__('JSON import should be done on the "<a href="%s">Maps list</a>" tab', 'usa2level-html5-map'), "admin.php?page=usa2level-map-plugin-maps");
        }
        elseif ( ! in_array($_FILES['csv-file']['type'], $types)) {
            $errors[] = __('Wrong file type!', 'usa2level-html5-map');
        }
    }
    $fd = stripslashes($_REQUEST['field-delimiter']);
    $td = stripslashes($_REQUEST['text-delimiter']);
    if ( ! array_key_exists($fd, $field_delimiters)) {
         $errors[] = __('Wrong field delimiter!', 'usa2level-html5-map');
    }
    else {
        $fd = $field_delimiters[$fd];
    }
    if ( ! array_key_exists($td, $text_delimiters)) {
         $errors[] = __('Wrong text delimiter!', 'usa2level-html5-map').$td;
    }
    else {
        $td = $text_delimiters[$td];
    }
    $importExportKeys = usa2level_map_plugin_get_csv_import_export_keys();
    $fields = array_keys($importExportKeys);
    if ($errors)
        return false;

    ini_set('auto_detect_line_endings', true);
    $fh = fopen($_FILES['csv-file']['tmp_name'], 'r');
    $head = fgetcsv($fh, 0, $fd, $td);
    if ( ! $head) {
        $errors[] = __('Wrong csv file!', 'usa2level-html5-map');
        return false;
    }
    if ( ! ($head[0] == $fields[0] and $head[1] == $fields[1] and $head[2] == $fields[2])) {
        $errors[] = __('Wrong csv header!', 'usa2level-html5-map');
        return false;
    }
    $data = array();
    while ($line = fgetcsv($fh, 0, $fd, $td)) {
        $data[trim($line[0])] = array();
        foreach ($head as $i => $k)
            $data[trim($line[0])][$k] = trim($line[$i]);
    }
    fclose($fh);
    unlink($_FILES['csv-file']['tmp_name']);

    $all_options = get_site_option('usa2levelhtml5map_options', array());
    $options_keys = array_keys($all_options);
    $def_map_id = reset($options_keys);

    $map_id = isset($_GET['map_id']) ? (int)$_GET['map_id'] : $def_map_id;

    $map_options = &$all_options[$map_id];
    $id2cfg_map = $map_options['id2cfg'];
    unset($importExportKeys['id'], $importExportKeys['info']);
    $fields = array_keys($importExportKeys);
    foreach ($map_options['states'] as $st_cfg_name => $st_params) {
        $st_params = json_decode($st_params, true);
        foreach ($st_params as $id => &$params) {
            if (!isset($data[$id]))
                continue;
            $has_substates = isset($id2cfg_map[$id]);
            if (isset($data[$id]['info']))
                $map_options['info'][$id] = $data[$id]['info'];
            foreach ($fields as $f) {
                $params[$f] = isset($data[$id][$f]) ? $data[$id][$f] : '';
            }
            if ($params['clickAction'] === '') {
                if (!empty($params['url']))
                    $params['clickAction'] = strpos('usa2levelhtml5map_map_set_state_text', $params['url']) ? 'info' : 'link';
                elseif ($has_substates)
                    $params['clickAction'] = 'substates';
                elseif (!empty($map_options['info'][$id]))
                    $params['clickAction'] = 'info';
                else
                    $params['clickAction'] = 'none';
            }
            switch ($params['clickAction']) {
                case 'info':
                    $params['showInfo'] = true;
                    $params['url'] = '';
                    break;
                case 'link':
                    if ($params['target'] and ! in_array($params['target'], array('_self', '_parent', '_top'))) {
                        $params['isNewWindow'] = true;
                    } else {
                        $params['isNewWindow'] = false;
                    }
                    break;
                case 'substatesAndInfo':
                    $params['showInfo'] = true;
                case 'substates':
                    $params['url'] = '';
                    if ($has_substates) $params['allowOpen'] = true;
                    break;
                case 'none':
                    $params['url'] = '';
                    if ($has_substates) $params['allowOpen'] = false;
                    else unset($params['allowOpen']);
                    break;
            }
            $params['popup_type'] = 1;
            unset($params['clickAction']);
            unset($data[$id]);
        }
        unset($params);
        $st_params = json_encode($st_params, defined('JSON_UNESCAPED_UNICODE') ? JSON_UNESCAPED_UNICODE : null);
        if ($st_params)
            $map_options['states'][$st_cfg_name] = $st_params;
        else
            $errors[] = __('Failed to encode new data! Probably non UTF data.', 'usa2level-html5-map');
    }
    if (count($data)) {
        $errors[] = __('Some data left unimported! Looks like wrong map.', 'usa2level-html5-map');
    }

    if ($errors) {
        return false;
    }
    update_site_option('usa2levelhtml5map_options', $all_options);
    return true;
}

function usa2level_map_plugin_map_selector($page, $map_id, &$options) {
?>
<script type="text/javascript">
jQuery(function($){
    $('select[name=map_id]').change(function() {
        location.href='admin.php?page=usa2level-map-plugin-<?php echo $page ?>&map_id='+$(this).val();
    });
    $('.tipsy-q').tipsy({gravity: 'w'}).find('span').css('cursor', 'default');
});
</script>
<span class="title" style="width: 100px"><?php echo __('Select a map:', 'usa2level-html5-map'); ?> </span>
    <select name="map_id" style="width: 185px;">
        <?php foreach($options as $id => $map_data) { ?>
            <option value="<?php echo $id; ?>" <?php echo ($id==$map_id) ? 'selected' : '';?>><?php echo $map_data['map']['name']; ?></option>
        <?php } ?>
    </select>
    <span class="tipsy-q" original-title="<?php esc_attr_e('Select a map for editing and previewing', 'usa2level-html5-map'); ?>">[?]</span>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <a href="admin.php?page=usa2level-map-plugin-maps" class="page-title-action tipsy-q" original-title="<?php esc_attr_e('List of all maps, creating a new map, backup', 'usa2level-html5-map'); ?>"><?php _e('Maps dashboard', 'usa2level-html5-map'); ?></a>
<?php
}


function usa2level_map_plugin_nav_tabs($page, $map_id)
{
?>
    <h2 class="nav-tab-wrapper">
        <a href="?page=usa2level-map-plugin-options&map_id=<?php echo $map_id ?>" class="nav-tab <?php echo $page == 'options' ? 'nav-tab-active' : '' ?>"><?php _e('General settings', 'usa2level-html5-map') ?></a>
        <a href="?page=usa2level-map-plugin-states&map_id=<?php echo $map_id ?>" class="nav-tab <?php echo $page == 'states' ? 'nav-tab-active' : '' ?>"><?php _e('Detailed settings', 'usa2level-html5-map') ?></a>
        <a href="?page=usa2level-map-plugin-points&map_id=<?php echo $map_id ?>" class="nav-tab <?php echo $page == 'points' ? 'nav-tab-active' : '' ?>"><?php _e('Points settings', 'usa2level-html5-map') ?></a>
        <a href="?page=usa2level-map-plugin-view&map_id=<?php echo $map_id ?>" class="nav-tab <?php echo $page == 'view' ? 'nav-tab-active' : '' ?>"><?php _e('Preview', 'usa2level-html5-map') ?></a>
    </h2>
<?php
}

function usa2level_map_plugin_draw_map_menu($page, &$map_options, $map_id, $current_continent, array $states, $prefix = '')
{
    if ( ! $states)
        $cur_state_id = -1;
    else
        $cur_state_id = array_shift($states);

    static $titles      = NULL;
    static $title_other = NULL;
    static $back_title  = NULL;
    if (is_null($titles)) {
        $titles = array(
            __('Select a state', 'usa2level-html5-map'),
            __('Select a county', 'usa2level-html5-map'),
            __('Select a region', 'usa2level-html5-map')
        );
        $title_other = __('Select an area', 'usa2level-html5-map');
        $back_title  = __('Go back', 'usa2level-html5-map');
    }

    $level = substr_count($prefix, ':');
    $title = ($cur_state_id != -1) ? $back_title : (isset($titles[$level]) ? $titles[$level] : $title_other);

    $action  = $prefix=='' ?
        "document.location.href = 'admin.php?page=usa2level-map-plugin-$page&map_id=$map_id&state_id='+(this.value!='0'?this.value:'')" :
        "document.location.href = 'admin.php?page=usa2level-map-plugin-$page&map_id=$map_id&state_id='+(this.value != 0 ? this.value : '".rtrim($prefix, ':')."')";

    $str = "<select name=\"continent_select\" onchange=\"$action\">
        <option value=\"0\">".$title."</option>";
    foreach($current_continent as $_cid=>$vals)
    {
        if($vals['name']) {
        $str .= "<option value=\"{$prefix}{$_cid}\" ".( $cur_state_id == $_cid ? ' selected' : '').">$vals[name]</option>";
        }
    }
    $str .="</select>";

    if (isset($current_continent[$cur_state_id]['config']) and $current_continent[$cur_state_id]['config'] != "") {
        $next_continent = json_decode($map_options['states'][$current_continent[$cur_state_id]['config']], true);

        $str .= usa2level_map_plugin_draw_map_menu($page, $map_options, $map_id, $next_continent, $states, $prefix.$cur_state_id.':');
    }
    return $str;
}

function usa2level_map_plugin_draw_map_menu2($page, &$map_options, $map_id, $current_continent, array $states, $prefix = '')
{
    if ( ! $states)
        $cur_state_id = -1;
    else
        $cur_state_id = array_shift($states);

    static $titles      = NULL;
    static $title_other = NULL;
    static $back_title  = NULL;
    if (is_null($titles)) {
        $titles = array(
            __('Select a state', 'usa2level-html5-map'),
            __('Select a county', 'usa2level-html5-map'),
            __('Select a region', 'usa2level-html5-map')
        );
        $title_other = __('Select an area', 'usa2level-html5-map');
        $back_title  = __('Go back', 'usa2level-html5-map');
    }

    $level = substr_count($prefix, ':');
    $title = ($cur_state_id != -1) ? $back_title : (isset($titles[$level]) ? $titles[$level] : $title_other);

    $action  = $prefix=='' ?
        "document.location.href = 'admin.php?page=usa2level-map-plugin-$page&map_id=$map_id&state_id='+(this.value!='0'?this.value:'')" :
        "document.location.href = 'admin.php?page=usa2level-map-plugin-$page&map_id=$map_id&state_id='+(this.value != 0 ? this.value : '".rtrim($prefix, ':')."')";

    $to_draw = array();
    foreach($current_continent as $_cid=>$vals) {
    if (!isset($map_options['id2cfg'][$_cid]))
            continue;
        if($vals['name']) {
            $to_draw[] = "<option value=\"{$prefix}{$_cid}\" ".( $cur_state_id == $_cid ? ' selected' : '').">$vals[name]</option>";
        }
    }
    if (!$to_draw)
        return "";
    $str = "<select name=\"continent_select{$level}\" onchange=\"$action\">
        <option value=\"0\">".$title."</option>";
    foreach($current_continent as $_cid=>$vals)
    {
        if (!isset($map_options['id2cfg'][$_cid]))
            continue;
        if($vals['name']) {
        $str .= "<option value=\"{$prefix}{$_cid}\" ".( $cur_state_id == $_cid ? ' selected' : '').">$vals[name]</option>";
        }
    }
    $str .="</select>";

    if (isset($current_continent[$cur_state_id]['config'])) {
        $next_continent = json_decode($map_options['states'][$current_continent[$cur_state_id]['config']], true);

        $str .= usa2level_map_plugin_draw_map_menu2($page, $map_options, $map_id, $next_continent, $states, $prefix.$cur_state_id.':');
    }
    return $str;
}

function usa2level_map_plugin_get_options($blog_id = null, $option_name = "usa2levelhtml5map_options") {
    $res = is_multisite() ?
        get_blog_option(is_null($blog_id) ? get_current_blog_id() : $blog_id, $option_name) :
        get_site_option($option_name);
    return $res ? $res : array();
}

function usa2level_map_plugin_save_options(&$options, $blog_id = null, $option_name = "usa2levelhtml5map_options") {
    if ( is_multisite() ) {
        update_blog_option(is_null($blog_id) ? get_current_blog_id() : $blog_id, $option_name, $options);
    } else {
        update_site_option($option_name, $options);
    }
}

function usa2level_map_plugin_delete_options($blog_id = null, $option_name = "usa2levelhtml5map_options") {
    if ( is_multisite() ) {
        delete_blog_option(is_null($blog_id) ? get_current_blog_id() : $blog_id, $option_name);
    } else {
        delete_site_option($option_name);
    }
}

function usa2level_map_plugin_escape_fonts($fonts, $addFonts = false) {
    $fonts = $fonts ? explode(',', $fonts) : array();
    if ($addFonts)
        $fonts = array_merge($fonts, explode(',', $addFonts));

    foreach ($fonts as &$f) {
        $f = '\''.trim($f, ' \'"').'\'';
    }
    return implode(',', $fonts);
}
